set_perm_recursive "$MODPATH"/assets 0 0 0755 0644 u:object_r:system_file:s0
set_perm_recursive "$MODPATH"/iris 0 0 0755 0644 u:object_r:system_file:s0

model=$(getprop ro.product.vendor.model)
marketname=$(getprop ro.vendor.oplus.market.name)
brand=$(getprop ro.product.brand)
kernel_version=$(uname -r)
ota_ver=$(getprop persist.sys.oplus.ota_ver_display)
sdk_ver=$(getprop ro.build.version.sdk)
android_ver=$(getprop ro.build.version.release)
soc_model=$(getprop ro.soc.model)
HYPROP="$MODPATH"/module.prop
DESC_ZH="赐予新生！为 $marketname！"
DESC_EN="Bestow a rebirth upon $marketname\."
DESC_FR="Accordez une renaissance à $marketname\."
hydro_version=$(grep_prop version "$HYPROP")
hydro_versionCode=$(grep_prop versionCode "$HYPROP")
settings="$MODPATH"/settings.txt
settings_old=/data/adb/modules/ab_optimizer/settings.txt
asopt_current=268
egt_current=40004

# OnePlus unzip functions

hydro_model(){
    if [ -n "$(ls /odm/etc/camera/config | grep Main)" ]; then
        model_product="$(ls /odm/etc/camera/config | grep Main | cut -d 'M' -f 1)"
        brand_op="oppo"
    elif [ -n "$(ls /odm/etc/camera/config | grep main)" ]; then
        model_product="$(ls /odm/etc/camera/config | grep main | cut -d 'm' -f 1)"
        brand_op="realme"
    else
        model_product="$model"
    fi
    case "$model_product" in
    PHB110|CPH2247|CPH2249|CPH2251) # 11
        [ "$model" != "PHB110" ] && os_ver_ex=1 && model="PHB110"
        has_iris="7"
        kernel_ver="5150"
        dis_spkrprot=1
        low_perf_device=1
        ;;
    PJD110|CPH2583|CPH2573|CPH2581) # 12
        [ "$model" != "PJD110" ] && os_ver_ex=1 && model="PJD110"
        has_iris="7"
        kernel_ver="6010"
        ins_camera="12"
        dis_spkrprot=1
        ;;
    PGP110|CPH2413|CPH2415|CPH2417) # Ace Pro/ 10T
        [ "$model" != "PGP110" ] && os_ver_ex=1 && model="PGP110"
        has_iris="7"
        kernel_ver="5100"
        not_ins_soundfx=1
        low_perf_device=1
        ;;
    PHK110|CPH2487) # Ace 2/ 11R
        [ "$model" != "PHK110" ] && os_ver_ex=1 && model="PHK110"
        has_iris="7"
        kernel_ver="5100"
        not_choose_dax=1
        low_perf_device=1
        ;;
    PJA110) # Ace 2 Pro
        has_iris="7"
        kernel_ver="5150"
        dis_spkrprot=1
        low_perf_device=1
        ;;
    PJE110|CPH2585|CPH2609|CPH2611) # Ace 3/ 12R
        [ "$model" != "PJE110" ] && os_ver_ex=1 && model="PJE110"
        has_iris="7p"
        kernel_ver="5150"
        ins_camera="ace3"
        dis_spkrprot=1
        ;;
    PJF110) # Ace 3V
        model="PJF110"
        has_iris="0"
        kernel_ver="6010"
        low_perf_device=1
        ;;
    PJX110) # Ace 3 Pro
        has_iris="7p"
        kernel_ver="6010"
        ins_camera="ace3p"
        not_ins_dolby=1
        ins_comf_brightness=1
        ;;
    giulia|PKG110|CPH2645|CPH2691|CPH2647) # Ace 5
        [ "$model" != "PKG110" ] && os_ver_ex=1 && model_product="giulia"
        has_iris="0"
        kernel_ver="6010"
        not_ins_dolby=1
        ins_comf_brightness=1
        dis_spkrprot=1
        ;;
    hummer|PKR110) # Ace 5 Pro
        has_iris="0"
        kernel_ver="6063"
        not_ins_dolby=1
        ins_comf_brightness=1
        dis_spkrprot=1
        raw_supported=1
        ;;
    pagani) # 13T
        [ "$model" != "PKX110" ] && os_ver_ex=1
        has_iris="0"
        kernel_ver="6063"
        not_ins_dolby=1
        ins_comf_brightness=1
        dis_spkrprot=1
        raw_supported=1
        ;;
    dodge) # 13
        [ "$model" != "PJZ110" ] && os_ver_ex=1
        has_iris="0"
        kernel_ver="6063"
        not_ins_dolby=1
        ins_comf_brightness=1
        dis_spkrprot=1
        raw_supported=1
        ;;
    CPH2551) # Open
        has_iris="0"
        kernel_ver="5150"
        not_choose_dax=1
        ins_comf_brightness=1
        dis_spkrprot=1
        low_perf_device=1
        ;;
    PHN110) # Find N3
        has_iris="0"
        kernel_ver="5150"
        not_choose_dax=1
        ins_comf_brightness=1
        dis_spkrprot=1
        low_perf_device=1
        ;;
    CPH2661) # Nord 4
        has_iris="0"
        kernel_ver="6010"
        not_ins_dolby=1
        ins_comf_brightness=1
        low_perf_device=1
        ;;
    OPD2404|OPD2403) # Pad Pro/ Pad 2
        model="OPD2404"
        has_iris="0"
        kernel_ver="6010"
        not_ins_vibration=1
        not_ins_dolby=1
        ins_comf_brightness=1
        not_sigpulse=1
        dis_spkrprot=1
        ;;
    OPD2407) # Pad
        has_iris="0"
        kernel_ver="6010"
        not_ins_vibration=1
        not_ins_soundfx=1
        ins_comf_brightness=1
        not_sigpulse=1
        ;;
    RMX3366) # GT Master
        has_iris="0"
        kernel_ver="4190"
        not_ins_vibration=1
        not_sigpulse=1
        ;;
    RMX3888) # GT 5 Pro
        has_iris="0"
        kernel_ver="6010"
        dis_spkrprot=1
        ;;
    RMX3850|RMX3852) # GT Neo 6 & SE
        model="RMX3850"
        has_iris="0"
        kernel_ver="6010"
        not_ins_dolby=1
        dis_spkrprot=1
        ;;
    RMX3820|RMX3823) # GT 5 
        model="RMX3820"
        has_iris="7"
        kernel_ver="5150"
        ;;
    RMX3551) # GT 2 Master
        has_iris="7"
        kernel_ver="5100"
        not_ins_soundfx=1
        ;;
    RMX3800) # GT 6
        has_iris="0"
        kernel_ver="6010"
        not_ins_dolby=1
        dis_spkrprot=1
        ;;
    caymana|RMX5060) # Neo 7
        has_iris="0"
        kernel_ver="6010"
        not_ins_soundfx=1
        ;;
    RMX5080) # Neo 7 SE
        has_iris="0"
        kernel_ver="6063"
        not_ins_soundfx=1
        ;;
    RMX3920|RMX3989) # Realme 13 Pro Series
        model="RMX3920"
        has_iris="0"
        kernel_ver="6010"
        not_ins_dolby=1
        dis_spkrprot=1
        ;;
    RMX5010) # GT 7 Pro
        has_iris="0"
        kernel_ver="6063"
        not_ins_dolby=1
        dis_spkrprot=1
        ins_comf_brightness=1
        raw_supported=1
        ;;
    targa|RMX6688) # GT 7
        has_iris="0"
        kernel_ver="6063"
        ins_comf_brightness=1
        not_ins_soundfx=1
        ;;
    *)
        hydro_unsupported_device
        ;;
    esac
}

hydro_unzip_model(){
    hydro_unzip
    case "$model_product" in
    PHB110)
        mv "$MODPATH"/soundfx/b/odm/etc/3_2p_11-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PHK110)
        mv "$MODPATH"/soundfx/b/odm/etc/dolby/ace2.xml "$MODPATH"/soundfx/b/odm/etc/dolby/multimedia_dolby_dax_default.xml
        mv "$MODPATH"/soundfx/b/odm/etc/3_2p_11-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PJD110)
        mv "$MODPATH"/soundfx/b/odm/etc/12_gt5p-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/odm/etc/12_resm.xml "$MODPATH"/soundfx/b/odm/etc/resourcemanager.xml  #Probably causing instability
        rm -f "$MODPATH"/soundfx/b/odm/etc/a3p_resm.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PJA110)
        mv "$MODPATH"/soundfx/b/odm/etc/3_2p_11-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PJE110)
        mv "$MODPATH"/soundfx/b/odm/etc/3_2p_11-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PJF110|CPH2661)
        mv "$MODPATH"/soundfx/b/odm/etc/3v_neo6se-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    PJX110)
        mv "$MODPATH"/soundfx/b/odm/etc/a3p-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/odm/etc/a3p-resm.xml "$MODPATH"/soundfx/b/odm/etc/resourcemanager.xml  #Probably causing instability
        rm -f "$MODPATH"/soundfx/b/odm/etc/12_resm.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    dodge)
        mv "$MODPATH"/soundfx/c/odm/etc/13-mixer_paths.xml "$MODPATH"/soundfx/c/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/c/odm/etc/13-resm.xml "$MODPATH"/soundfx/c/odm/etc/resourcemanager.xml  #Probably causing instability
        ;;
    hummer)
        mv "$MODPATH"/soundfx/c/odm/etc/a5p-mixer_paths.xml "$MODPATH"/soundfx/c/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/c/odm/etc/a5p-resm.xml "$MODPATH"/soundfx/c/odm/etc/resourcemanager.xml  #Probably causing instability
        ;;
    pagani)
        mv "$MODPATH"/soundfx/c/odm/etc/13t-mixer_paths.xml "$MODPATH"/soundfx/c/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/c/odm/etc/13t-resm.xml "$MODPATH"/soundfx/c/odm/etc/resourcemanager.xml  #Probably causing instability
        ;;
    giulia)
        mv "$MODPATH"/soundfx/b/odm/etc/a5-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/odm/etc/a5-resm.xml "$MODPATH"/soundfx/b/odm/etc/resourcemanager.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    CPH2551|PHN110)
        mv "$MODPATH"/soundfx/b/odm/etc/dolby/open-dax.xml "$MODPATH"/soundfx/b/odm/etc/dolby/multimedia_dolby_dax_default.xml
        mv "$MODPATH"/soundfx/b/odm/etc/open-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/odm/etc/open-resm.xml "$MODPATH"/soundfx/b/odm/etc/resourcemanager.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    RMX3888)
        mv "$MODPATH"/soundfx/b/odm/etc/12_gt5p-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml
        ;;
    RMX3850)
        mv "$MODPATH"/soundfx/b/odm/etc/3v_neo6se-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    RMX3820)
        mv "$MODPATH"/soundfx/b/odm/etc/3_2p_11-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml
        ;;
    RMX3800)
        mv "$MODPATH"/soundfx/b/odm/etc/gt6-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml
        ;;
    RMX3920)
        mv "$MODPATH"/soundfx/b/odm/etc/r13p-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml
        ;;
    OPD2404)
        mv "$MODPATH"/soundfx/b/odm/etc/padpro-mixer_paths.xml "$MODPATH"/soundfx/b/odm/etc/mixer_paths.xml
        mv "$MODPATH"/soundfx/b/odm/etc/padpro-resm.xml "$MODPATH"/soundfx/b/odm/etc/resourcemanager.xml
        mv "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/gt5p-resourcemanager_cliffs_mtp.xml "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/resourcemanager_cliffs_mtp.xml
        rm -f "$MODPATH"/soundfx/b/system/vendor/etc/audio/sku_cliffs/normal-resourcemanager_cliffs_mtp.xml
        ;;
    esac
    sed -i "s/OnePlus PJE110/$brand $model/g" "$MODPATH"/assets/hardware_model_config.json
    [ -n "$not_sigpulse" ] && sed -i '/<SinglePulseDimmingSupport>/,/<\/SinglePulseDimmingSupport>/d' "$MODPATH"/assets/display_brightness_app_list.xml
    #mv "$MODPATH"/assets/sys_perf_config.json "$MODPATH"/my_product/etc/sys_perf_config.json
    mv "$MODPATH"/assets/display_brightness_app_list.xml "$MODPATH"/my_product/vendor/etc/display_brightness_app_list.xml
    mv "$MODPATH"/assets/com_oplus_smartsidebar_space_roulette_support.xml "$MODPATH"/my_product/etc/extension/com_oplus_smartsidebar_space_roulette_support.xml
    mv "$MODPATH"/assets/config_product_com.android.providers.settings.xml "$MODPATH"/my_product/etc/extension/config_product_com.android.providers.settings.xml
}

# OnePlus unzip functions end

hydro_print(){
    sleep 0.05
    ui_print "$1"
}

hydro_abort(){
    ui_print ""
    ui_print ""
    ui_print ""
    abort
}

print_line(){
    hydro_print "——————————"
}

hydro_unsupported_device(){
    case $lang in
    zh)
        hydro_print "未受支持的设备！"
        hydro_print "请确保你没有使用任何伪装机型的模块"
        hydro_abort
        ;;
    en)
        hydro_print "Unsupported device!"
        hydro_print "'Make sure you are not using any modules that disguise your model"
        hydro_abort
        ;;
    fr)
        hydro_print "Périphérique non pris en charge!"
        hydro_print "'Assurez-vous que vous n'utilisez aucun module qui masque votre modèle"
        hydro_abort
        ;;
    esac
}

hydro_language_select(){
    hydro_print "请选择您的语言/Choose your language/Choisissez votre langue"
    hydro_print "音量键 + : 简体中文"
    hydro_print "Volume - : English/Français"
    while [ "$key_click_en" = "" ]; do
        key_click_en=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_en in
    KEY_VOLUMEUP)
        hydro_print "--已选择语言: 简体中文"
        lang="zh"
        sed -i "s/^description=.*$/description=$DESC_ZH/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    *)
        hydro_language_choose_fr_en
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_language_choose_fr_en(){
    hydro_print "Volume + : Français"
    hydro_print "Volume - : English"
    while [ "$key_click_fr" = "" ]; do
        key_click_fr=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_fr in
    KEY_VOLUMEUP)
        hydro_print "--Langue actuelle : Français"
        lang="fr"
        sed -i "s/^description=.*$/description=$DESC_FR/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/README.md
        ;;
    *)
        hydro_print "--Current language: English"
        lang="en"
        sed -i "s/^description=.*$/description=$DESC_EN/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    esac
}

hydro_kernel_version(){
    if [[ $kernel_version == *"Yuni"* ]]; then
        h_yuni_kernel=1
    elif [[ $kernel_version == *"AngelBeats"* ]]; then
        h_yuni_kernel=2
    elif [[ $kernel_version == *"Pandora"* ]]; then
        h_yuni_kernel=3
    else
        h_yuni_kernel=0
    fi
    if [ -f "/data/adb/modules/pandora_kernel/remove" -o -f "/data/adb/modules/yuni_kernel/remove" -o -f "/data/adb/modules/angelbeats_kernel/remove" ]; then
        h_yuni_kernel=0
    fi
    if [[ $h_yuni_kernel -gt 0 ]]; then
        is_pandora=1
    else
        is_pandora=0
    fi
}

hydro_model_detect(){
    case $lang in
    zh)
        hydro_print "--设备信息--"
        hydro_print "产品名称：$model_product"
        hydro_print "市场名称：$marketname"
        hydro_print "内核版本：$kernel_version"
        hydro_print "模块版本：$hydro_version ($hydro_versionCode)"
        hydro_print "系统版本：$ota_ver"
        hydro_print "安卓版本：$android_ver（$sdk_ver）"
        ;;
    en)
        hydro_print "--Device info--"
        hydro_print "Product name: $model_product"
        hydro_print "Market name: $marketname"
        hydro_print "Kernel version: $kernel_version"
        hydro_print "Hydro version: $hydro_version ($hydro_versionCode)"
        hydro_print "System version: $ota_ver"
        hydro_print "Android version: $android_ver（$sdk_ver）"
        ;;
    fr)
        hydro_print "--Info appareil--"
        hydro_print "Nom du produit: $model_product"
        hydro_print "Nom du marché: $marketname"
        hydro_print "Version du noyau: $kernel_version"
        hydro_print "Version du module: $hydro_version ($hydro_versionCode)"
        hydro_print "Version du système: $ota_ver"
        hydro_print "Version Android: $android_ver（$sdk_ver）"
        ;;
    esac
    if [ "$KSU" = "true" ]; then
        hydro_print "KernelSU: $KSU_VER_CODE"
    elif [ "$APATCH" = "true" ]; then
        hydro_print "APatch: $APATCH_VER_CODE"
    else
        hydro_print "Magisk: $MAGISK_VER_CODE"
        if [ "$MAGISK_VER_CODE" -lt 26000 ]; then
            case $lang in
            zh)
                hydro_print "请更新 Magisk 以使用本模块"
                hydro_abort
                ;;
            en)
                hydro_print "Outdated Magisk detected, please update!"
                hydro_abort
                ;;
            fr)
                hydro_print "Magisk obsolète détecté, veuillez mettre à jour !"
                hydro_abort
                ;;
            esac
        fi
    fi
    if [ "$sdk_ver" -lt 34 ]; then
        case "$lang" in
        zh)
            hydro_print "您的安卓版本低于14，本模块可能无法正常工作，请知悉"
            ;;
        en)
            hydro_print "Your Android version is lower than 14"
            hydro_print "The module may not work properly, please be aware"
            ;;
        fr)
            hydro_print "Votre version Android est inférieure à 14"
            hydro_print "Le module peut ne pas fonctionner correctement, soyez-en conscient"
            ;;
        esac
    fi
    hydro_model
    sleep 0.5
    print_line
    hydro_environment_detect
}

hydro_environment_detect(){
    sed -i '/# Test sed for Magisk/,/# Test sed for Magisk fin./d' "$MODPATH"/assets/functions.sh
    sed -i '/# Test sed for Magisk/,/# Test sed for Magisk fin./d' "$MODPATH"/system.prop
    if [ "`sed -n '/# Test sed for Magisk/p' "$MODPATH"/system.prop`" -o "`sed -n '/# Test sed for Magisk/p' "$MODPATH"/assets/functions.sh`" ]; then
        print_line
        case "$lang" in
        zh)
            hydro_print "抱歉，你的 Magisk 不能正常工作，本模块将不会被安装！"
            ;;
        en)
            hydro_print "Sorry, your Magisk is not running properly, the module will not be installed! "
            ;;
        fr)
            hydro_print "Magisk ne fonctionne pas correctement et le module ne sera pas installé! "
            ;;
        esac
        print_line
        hydro_abort
    fi
}

hydro_unzip(){
    for file in "$MODPATH"/platform_config/$model_product/*; do
        cp -r $file "$MODPATH"
    done
    rm -rf "$MODPATH"/platform_config
    if [ $kernel_ver = "5150" ]; then
        mv "$MODPATH"/kernel_modules/zram515.ko "$MODPATH"/kernel_modules/zram.ko
        rm -f "$MODPATH"/kernel_modules/zram61.ko
        rm -f "$MODPATH"/kernel_modules/zram510.ko
    elif [ $kernel_ver = "6010" ]; then
        mv "$MODPATH"/kernel_modules/zram61.ko "$MODPATH"/kernel_modules/zram.ko
        rm -f "$MODPATH"/kernel_modules/zram515.ko
        rm -f "$MODPATH"/kernel_modules/zram510.ko
        rm -rf "$MODPATH"/system/bin
    elif [ $kernel_ver = "5100" ]; then
        mv "$MODPATH"/kernel_modules/zram510.ko "$MODPATH"/kernel_modules/zram.ko
        rm -f "$MODPATH"/kernel_modules/zram515.ko
        rm -f "$MODPATH"/kernel_modules/zram61.ko
        rm -rf "$MODPATH"/system/bin
    else
        rm -f "$MODPATH"/kernel_modules
        rm -rf "$MODPATH"/system/bin
        not_ins_memopt="1"
    fi
}

unins_module(){
    touch "$1/remove"
    if [ "$KSU" != "true" ] && [ "$APATCH" != "true" ]; then
        rm -f "$1/service.sh"
        rm -f "$1/post-fs-data.sh"
        rm -f "$1/system.prop"
    fi
}

unins_select(){
    case $lang in
    zh)
        [ "$5" = "-1" ] && hydro_print "检测到 $3，请卸载此人的模块，否则将终止安装"
        [ "$5" = "1" ] && hydro_print "检测到冲突，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "5" ] && hydro_print "检测到已启用冲突的功能，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "0" ] && hydro_print "检测到可能的冲突，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "0" ] && [ "$conflict_prompt" = "" ] && hydro_print "若您存在语言功能障碍，请自行查阅\"可能\"一词的含义"
        conflict_prompt="1"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "检测到来自 $3 的 $2 模块存在与服务器通讯的行为"
            [ "$5" = "3" ] && hydro_print "检测到来自 $3 的 $2 模块存在使用 /dev/zero 的行为"
            [ "$5" = "4" ] && hydro_print "检测到来自 $3 的 $2 模块存在过长的 echo 命令，可能存在加密"
            hydro_print "请确保此模块的来源正当，否则存在损坏设备的风险"
            hydro_print "如果来源不明，请按音量键 + 以卸载"
        fi
        hydro_print "音量键 + : 是的"
        hydro_print "音量键 - : 不，我需要保留它"
        ;;
    en)
        [ "$5" = "-1" ] && hydro_print "$3 is detected, please uninstall his module, otherwise the installation will be forcibly cancelled"
        [ "$5" = "1" ] && hydro_print "Conflict detected, would you like to uninstall module $2 from $3?"
        [ "$5" = "5" ] && hydro_print "Conflicting enabled features detected, would you like to uninstall the $2 module from $3?"
        [ "$5" = "0" ] && hydro_print "Possible conflict detected, would you like to uninstall module $2 from $3?"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "Detected module $2 from $3 communicating with server"
            [ "$5" = "3" ] && hydro_print "Detected behavior of module $2 from $3 using /dev/zero"
            [ "$5" = "4" ] && hydro_print "Detected excessively long echo command in $2 module from $3, possible encryption"
            hydro_print "Please ensure that this module comes from a trustworthy source,"
            hydro_print "otherwise there is a risk of damaging the device"
            hydro_print "If the source is unknown, press volume key + to uninstall"
        fi
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No, that's unacceptable"
        ;;
    fr)
        [ "$5" = "-1" ] && hydro_print "3$ sont détectés, veuillez désinstaller son module, sinon l'installation sera annulée de force"
        [ "$5" = "1" ] && hydro_print "Conflit détecté, souhaitez-vous désinstaller le module $2 de $3 ?"
        [ "$5" = "5" ] && hydro_print "Fonctionnalités activées en conflit détectées. Souhaitez-vous désinstaller le module à $2 de celui à $3 ?"
        [ "$5" = "0" ] && hydro_print "Conflit possible détecté, souhaitez-vous désinstaller le module $2 de $3 ?"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "Module détecté 2 $ sur 3 $ communiquant avec le serveur"
            [ "$5" = "3" ] && hydro_print "Comportement détecté du module $2 à partir de $3 en utilisant /dev/zero"
            [ "$5" = "4" ] && hydro_print "Commande d'écho trop longue détectée dans le module $2 à partir de $3, cryptage possible"
            hydro_print "Veuillez vous assurer que ce module provient d'une source fiable,"
            hydro_print "sinon il y a un risque d'endommager l'appareil"
            hydro_print "Si la source est inconnue, appuyez sur la touche de volume + pour désinstaller"
        fi
        hydro_print "Préféreriez-vous désinstaller le module $2 apporté par $3 ?"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non, c'est inacceptable"
        ;;
    esac
    local key_click_unins
    while [ "$key_click_unins" = "" ]; do
        key_click_unins=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_unins in
    KEY_VOLUMEUP)
        unins_module $1
        case $lang in
        zh)
            hydro_print "卸载完成"
            ;;
        en)
            hydro_print "Uninstallation completed, well done!"
            ;;
        fr)
            hydro_print "Désinstallation terminée, bravo !"
            ;;
        esac
        ;;
    *)
        if [ "$4" = "1" ]; then
            case $lang in
            zh)
                hydro_print "安装终止"
                ;;
            en)
                hydro_print "Installation terminated since not compatible with the module"
                ;;
            fr)
                hydro_print "Installation terminée car non compatible avec le module"
                ;;
            esac
            hydro_abort
        elif [ "$4" = "2" ]; then
            if [ "$6" = "1" ]; then
                key_click_1="KEY_VOLUMEDOWN"
            elif [ "$6" = "9" ]; then
                key_click_9="KEY_VOLUMEDOWN"
            elif [ "$6" = "3" ]; then
                key_click_3="KEY_VOLUMEDOWN"
                key_click_3_2="KEY_VOLUMEDOWN"
            elif [ "$6" = "0" ]; then
                key_click_0="KEY_VOLUMEDOWN"
            fi
            case $lang in
            zh)
                hydro_print "未卸载，已关闭本模块中对应的功能"
                ;;
            en)
                hydro_print "Not uninstalled, the corresponding function in the module has been closed"
                ;;
            fr)
                hydro_print "Non désinstallé, la fonction correspondante dans ce module a été fermée"
                ;;
            esac
        else
            case $lang in
            zh)
                hydro_print "未卸载该模块"
                [ "$not_unins_prompt" = "" ] && hydro_print "请确保你的行为是安全的，或自行承担可能的风险"
                ;;
            en)
                hydro_print "Retained the module"
                [ "$not_unins_prompt" = "" ] && hydro_print "Please ensure that your behavior is safe or bear the possible risks at your own risk"
                ;;
            fr)
                hydro_print "Le module n'est pas désinstallé"
                [ "$not_unins_prompt" = "" ] && hydro_print "Veuillez vous assurer que votre comportement est sûr ou supporter les risques possibles à vos propres risques"
                ;;
            esac
            not_unins_prompt="1"
        fi
        ;;
    esac
    sleep 0.3
    print_line
}

unins_bypass(){
    local module_prop="$1/module.prop"
    local name=$(grep_prop name "$module_prop")
    local author=$(grep_prop author "$module_prop")
    case $lang in
    zh)
        hydro_print "检测到来自 $author 的 $name 模块存在放行标识"
        hydro_print "请确保此模块来源安全"
        ;;
    en)
        hydro_print "Bypass flag detected for module $name from $author"
        hydro_print "Please ensure that the source of this module is safe"
        ;;
    fr)
        hydro_print "Indicateur de contournement détecté pour le module $name à partir de $author"
        hydro_print "Veuillez vous assurer que la source de ce module est sûre"
        ;;
    esac
    print_line
}

uninstall_module(){
    local module_prop="$1/module.prop"
    local name=$(grep_prop name "$module_prop")
    local author=$(grep_prop author "$module_prop")
    unins_select "$1" "$name" "$author" "$2" "$3" "$4"
}

hydro_fakemodel_abort(){
    case $lang in
    zh)
        hydro_print "检测到机型伪装模块，请将其卸载，重启后重新安装本模块"
        ;;
    en)
        hydro_print "Device model camouflage module detected"
        hydro_print "Please uninstall it and reinstall the module after rebooting"
        ;;
    fr)
        hydro_print "Module de camouflage du modèle d'appareil détecté"
        hydro_print "Veuillez le désinstaller et réinstaller le module après le redémarrage"
        ;;
    esac
    hydro_abort
}

heil_nakixii(){
    if [ ! -d "/data/adb/modules/asoul_affinity_opt" -a ! -d "/data/adb/modules_update/asoul_affinity_opt" ]; then
        case $lang in
        zh)
            hydro_print "未安装 A-SOUL Games Optimization 模块，即将自动安装"
            ;;
        en)
            hydro_print "A-SOUL Games Optimization module is not installed"
            hydro_print "It will be installed automatically"
            ;;
        fr)
            hydro_print "Le module A-SOUL Games Optimization n'est pas installé"
            hydro_print "ItIl sera installé automatiquement"
            ;;
        esac
        print_line
        if [ "$KSU" != "true" ] && [ "$APATCH" != "true" ]; then
            magisk --install-module "$MODPATH/assets/Asoul_Opt.zip"
        else
            case $lang in
            zh)
                hydro_print "请手动安装本模块压缩包中 /assets 内的模块"
                ;;
            en)
                hydro_print "Please install modules in /assets of the zip file manually"
                ;;
            fr)
                hydro_print "Veuillez installer manuellement les modules dans /assets du fichier zip"
                ;;
            esac
        fi
        print_line
    elif [ -f "/data/adb/modules/asoul_affinity_opt/module.prop" ]; then
        asopt_versionCode=$(grep_prop versionCode /data/adb/modules/asoul_affinity_opt/module.prop)
        author_A=$(grep_prop author "/data/adb/modules/asoul_affinity_opt/module.prop")
        if [ "$author_A" != "nakixii" ]; then
            case $lang in
            zh)
                hydro_print "检测到未授权版本的 A-SOUL Games Optimization 模块，已自动卸载"
                ;;
            en)
                hydro_print "Unauthorized version of A-SOUL Games Optimization module detected"
                ;;
            fr)
                hydro_print "Version non autorisée du module d'optimisation des jeux A-SOUL détectée"
                ;;
            esac
            unins_module "/data/adb/modules/asoul_affinity_opt"
        elif [ $asopt_versionCode -lt $asopt_current ]; then
            case $lang in
            zh)
                hydro_print "正在更新 A-SOUL Games Optimization 模块"
                ;;
            en)
                hydro_print "Updating A-SOUL Games Optimization module"
                ;;
            fr)
                hydro_print "Mise à jour du module A-SOUL Games Optimization"
                ;;
            esac
            print_line
            if [ "$KSU" != "true" ] && [ "$APATCH" != "true" ]; then
                magisk --install-module "$MODPATH/assets/Asoul_Opt.zip"
            else
                case $lang in
                zh)
                    hydro_print "请手动安装本模块压缩包中 /assets 内的模块"
                    ;;
                en)
                    hydro_print "Please install modules in /assets of the zip file manually"
                    ;;
                fr)
                    hydro_print "Veuillez installer manuellement les modules dans /assets du fichier zip"
                    ;;
                esac
            fi
            print_line
        fi
    fi
    rm -f "$MODPATH/assets/Asoul_Opt.zip"
}

heil_ski(){
    if [ ! -d "/data/adb/modules/extreme_gt" -a ! -d "/data/adb/modules_update/extreme_gt" ]; then
        case $lang in
        zh)
            hydro_print "未安装 Extreme GT 温控移除模块，即将自动安装"
            hydro_print "已获得 @嘟嘟斯基 授权修改"
            ;;
        en)
            hydro_print "Extreme GT Temperature Control Removal Module is not installed"
            hydro_print "It will be installed automatically"
            ;;
        fr)
            hydro_print "Le module de suppression du contrôle de température Extreme GT n’est pas installé et sera installé automatiquement"
            ;;
        esac
        print_line
        if [ "$KSU" != "true" ] && [ "$APATCH" != "true" ]; then
            magisk --install-module "$MODPATH/assets/Extreme_GT.zip"
        else
            case $lang in
            zh)
                hydro_print "请手动安装本模块压缩包中 /assets 内的模块"
                ;;
            en)
                hydro_print "Please install modules in /assets of the zip file manually"
                ;;
            fr)
                hydro_print "Veuillez installer manuellement les modules dans /assets du fichier zip"
                ;;
            esac
        fi
        print_line
    elif [ ! -f "/data/adb/modules/extreme_gt/ab_certified" -a ! -f "/data/adb/modules_update/extreme_gt/ab_certified" ]; then
        case $lang in
        zh)
            hydro_print "正在安装修改后的 Extreme GT 温控移除模块"
            hydro_print "已获得 @嘟嘟斯基 授权"
            ;;
        en)
            hydro_print "Installing modified Extreme GT temperature control removal module"
            ;;
        fr)
            hydro_print "Installation du module de suppression du contrôle de température Extreme GT modifié"
            ;;
        esac
        print_line
        magisk --install-module "$MODPATH/assets/Extreme_GT.zip"
        print_line
    elif [ -f "/data/adb/modules/extreme_gt/module.prop" -a -f "/data/adb/modules/extreme_gt/ab_certified" ]; then
        egt_versionCode=$(grep_prop versionCode /data/adb/modules/extreme_gt/module.prop)
        if [ $egt_versionCode -lt $egt_current ]; then
            case $lang in
            zh)
                hydro_print "正在更新 Extreme GT 模块"
                ;;
            en)
                hydro_print "Updating Extreme GT module"
                ;;
            fr)
                hydro_print "Mise à jour du module Extreme GT"
                ;;
            esac
            print_line
            if [ "$KSU" != "true" ] && [ "$APATCH" != "true" ]; then
                magisk --install-module "$MODPATH/assets/Extreme_GT.zip"
            else
                case $lang in
                zh)
                    hydro_print "请手动安装本模块压缩包中 /assets 内的模块"
                    ;;
                en)
                    hydro_print "Please install modules in /assets of the zip file manually"
                    ;;
                fr)
                    hydro_print "Veuillez installer manuellement les modules dans /assets du fichier zip"
                    ;;
                esac
            fi
            print_line
        fi
    fi
    rm -f "$MODPATH/assets/Extreme_GT.zip"
}

hydro_cure(){
    case $lang in
    zh)
        hydro_print "正在进行环境安全性检测，请耐心等待……"
        ;;
    en)
        hydro_print "Environmental safety testing is in progress, please wait patiently..."
        ;;
    fr)
        hydro_print "Les tests de sécurité environnementale sont en cours, veuillez patienter..."
        ;;
    esac
    print_line
    local dir
    local subdir
    for dir in /data/adb/modules /data/adb/modules_update; do
        for subdir in $(find "$dir" -maxdepth 1 -type d); do
            local module_prop="$subdir/module.prop"
            local system_prop="$subdir/system.prop"
            local service="$subdir/service.sh"
            local bypass="$subdir/ab_certified"
            local author=$(grep_prop author "$module_prop")
            local folder=$(basename "$subdir")
            if [ -f "$module_prop" -a ! -e "$bypass" -a ! -e "$subdir"/remove -a "$folder" != "ab_optimizer" -a "$folder" != "extreme_gt" -a "$author" != "嘟嘟ski" -a "$author" != "nakixii" ]; then
                if grep -q -i -e 'int萌新很新' -e '水竹闲士' -e 'color_fast_charge_sysbanch' "$module_prop"; then
                    uninstall_module "$subdir" "1" "-1"
                elif grep -q -e '/sdcard/Android/gs/' -e 'max_ma_rounded' "$service"; then
                    uninstall_module "$subdir" "1" "-1"
                elif grep -q -e 'scaling_min_freq' "$service"; then
                    uninstall_module "$subdir" "1" "1"
                elif grep -q -e 'ro.product.name' -e 'ro.product.brand' "$system_prop"; then
                    uninstall_module "$subdir" "1" "1"
                    hydro_fakemodel_abort
                elif grep -q -e '温控' -e 'thermal' "$module_prop"; then
                    uninstall_module "$subdir" "1" "1"
                elif find "$subdir"/ | grep -q -e 'com.oplus.oplus-feature.xml' -e 'report_rate_config.xml' -e 'sys_game_manager_config.json' -e 'iris_configs.xml' -e 'display_brightness_app_list.xml' -e 'multimedia_pixelworks_apps.xml' -e 'multimedia_pixelworks_game_apps.xml' -e 'oplus.product.display_features.xml' -e 'sys_thermal_config.xml'; then
                    uninstall_module "$subdir" "1" "1"
                fi
                if grep -q -i -e '充电' -e 'orms' -e '墓碑' -e '屏幕' -e '触控' -e '超频响应' -e 'vulkan' -e 'MEMC' -e 'ltpo' "$module_prop"; then
                    uninstall_module $subdir "0" "0"
                elif find "$subdir"/ | grep -q -i -e 'iris' -e 'pixelworks' -e 'oplus_vrr' -e 'refresh'; then
                    uninstall_module $subdir "0" "0"
                fi
                if [ "$key_click_0" != "KEY_VOLUMEDOWN" ]; then
                    if grep -q -i -e 'vulkan' -e 'hwui' "$system_prop"; then
                        uninstall_module $subdir "2" "5" "0"
                    fi
                fi
                if [ "$key_click_1" != "KEY_VOLUMEDOWN" ]; then
                    if grep -q -i -e 'olby' -e '哈曼' "$module_prop"; then
                        uninstall_module $subdir "2" "5" "1"
                    elif find "$subdir"/ | grep -q -i -e 'audio' -e 'dolby'; then
                        uninstall_module $subdir "2" "5" "1"
                    fi
                fi
                if [ "$key_click_9" != "KEY_VOLUMEDOWN" ]; then
                    if grep -q -i -e '震动' -e '振动' -e 'bration' -e 'brator' -e 'haptic' "$module_prop"; then
                        uninstall_module $subdir "2" "5" "9"
                    fi
                fi
                if [ "$key_click_3" != "KEY_VOLUMEDOWN" ]; then
                    if find "$subdir"/ | grep -q -i -e 'oplus_vrr_config.json'; then
                        uninstall_module $subdir "2" "5" "3"
                    fi
                fi
                if grep -q 'curl' "$service"; then
                    uninstall_module $subdir "0" "2"
                elif grep -q '/dev/zero' "$service"; then
                    uninstall_module $subdir "0" "3"
                fi
                while IFS= read -r line; do
                    if echo "$line" | grep -q "^echo" && [ "${#line}" -gt 100 ]; then
                        uninstall_module $subdir "0" "4"
                        break
                    fi
                done < "$service"
            elif [ -e "$bypass" -o "$author" = "嘟嘟ski" -o "$author" = "nakixii" ]; then
                unins_bypass $subdir
            fi
        done
    done
    #heil_nakixii # Disabled for incompatibility of offical scheduling on SM8650
    #heil_ski # Disabled for better thermal control
    case $lang in
    zh)
        hydro_print "环境检测完毕"
        ;;
    en)
        hydro_print "Environmental testing completed"
        ;;
    fr)
        hydro_print "Tests environnementaux terminés"
        ;;
    esac
    print_line
}

hydro_cure_select(){
    case $lang in
    zh)
        hydro_print "请选择是否进行安装环境检测"
        hydro_print "本流程会自动检测潜在的恶意模块以及冲突"
        hydro_print "如果存在冲突，本模块会自动避让相关的功能；"
        hydro_print "若无法避让，你可以选择卸载冲突模块或退出安装"
        hydro_print "注意！若跳过此流程，可能会导致部分功能冲突，甚至阻止设备正常工作"
        hydro_print "同时，你的任何反馈均不会被视作有效"
        hydro_print "音量键 + : 进行环境检测"
        hydro_print "音量键 - : 跳过环境检测"
        ;;
    en)
        hydro_print "Choose whether to have an environment detection"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : Skip"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez avoir une détection d'environnement"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_cure" = "" ]; do
        key_click_cure=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_cure in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        print_line
        hydro_cure
        ;;
    *)
        hydro_print "-- ✖"
        print_line
        ;;
    esac
}

hydro_iris_cfg_update(){
    if [ -f /data/adb/modules/ab_optimizer/iris/iriscfgcustomize.conf ]; then
        cp /data/adb/modules/ab_optimizer/iris/iriscfgcustomize.conf "$MODPATH"/iris/iriscfgcustomize.conf
    fi
}

hydro_enable_sfopt(){
    [ "$low_perf_device" != "1" ] && sed -i '/# Frameboost adjustment for better perf/,/# Frameboost fin./d' "$MODPATH"/system.prop
}

hydro_disable_sfopt(){
    sed -i '/## Renderer optimize/,/## Renderer optimize fin./d' "$MODPATH"/system.prop
    rm -f "$MODPATH/my_product/etc/sys_perf_config.json"
}

hydro_sfopt_install(){
    case $lang in
    zh)
        hydro_print "是否启用渲染优化？"
        hydro_print "本修改包括 surfaceflinger、系统动效调整"
        hydro_print "提供更高效的图形处理、更低的操作时延和更佳的动画体验"
        hydro_print "在过于旧的驱动和软件环境下可能会产生错误！"
        hydro_print "音量键 + : 开启渲染优化"
        hydro_print "音量键 - : 关闭渲染优化"
        ;;
    en)
        hydro_print "Choose whether to enable renderer optimization"
        hydro_print "Including surfaceflinger and system anim optimization"
        hydro_print "Provides more efficient graphics processing,"
        hydro_print "lower operation latency and smoother animation experience"
        hydro_print "Errors may occur in older driver and software environments"
        hydro_print "Volume + : Enable renderer optimization"
        hydro_print "Volume - : Disable renderer optimization"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation du moteur de rendu"
        hydro_print "Y compris l'optimisation d'urfaceflinger et l'insertion de trame dynamique"
        hydro_print "Fournit un traitement graphique plus efficace,"
        hydro_print "une latence de fonctionnement plus faible et une expérience d'animation plus fluide"
        hydro_print "Des erreurs peuvent survenir dans les anciens environnements de pilotes et de logiciels"
        hydro_print "Volume + : Activer l'optimisation du moteur de rendu"
        hydro_print "Volume - : Désactiver l'optimisation du moteur de rendu"
        ;;
    esac
    while [ "$key_click_0" = "" ]; do
        key_click_0=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_0 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enable_sfopt
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_sfopt
        ;;
    esac
    sleep 0.3
    print_line
}

hydro_enable_soundfx(){
    if [ "$model" = "RMX3366" ]; then
        hydro_enable_soundfx_a
    elif [ "$soc_model" = "SM8750" -o "$soc_model" = "SM8735" ]; then
        hydro_enable_soundfx_c
    else
        hydro_enable_soundfx_b
    fi
    rm -rf $MODPATH/soundfx
}

hydro_enable_soundfx_a(){
    cp -r -u "$MODPATH"/soundfx/a/odm "$MODPATH"
    cp -r -u "$MODPATH"/soundfx/a/my_product "$MODPATH"
    cp -r -u "$MODPATH"/soundfx/a/system "$MODPATH"
    sed -i '/# Start of B-tune/,/# End of B-tune/d' "$MODPATH"/system.prop
    sed -i '/# Start of C-tune/,/# End of C-tune/d' "$MODPATH"/system.prop
}

hydro_enable_soundfx_b(){
    cp -r -u "$MODPATH"/soundfx/b/odm "$MODPATH"
    cp -r -u "$MODPATH"/soundfx/b/my_product "$MODPATH"
    cp -r -u "$MODPATH"/soundfx/b/system "$MODPATH"
    [ ! -f "$MODPATH/odm/etc/audio_effects.xml" ] && cp /odm/etc/audio_effects.xml "$MODPATH"/odm/etc/audio_effects.xml
    [ ! -f "$MODPATH/odm/etc/resourcemanager.xml" ] && cp /odm/etc/resourcemanager.xml "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<param key="oplus_check_speaker" value="true"\/>/<param key="oplus_check_speaker" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    [ -n "$dis_spkrprot" ] && sed -i 's/<param key="oplus_lvve_err_fb" value="true"\/>/<param key="oplus_lvve_err_fb" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<speaker_protection_enabled>1<\/speaker_protection_enabled>/<speaker_protection_enabled>0<\/speaker_protection_enabled>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    sed -i '/# Start of A-tune/,/# End of A-tune/d' "$MODPATH"/system.prop
    sed -i '/# Start of C-tune/,/# End of C-tune/d' "$MODPATH"/system.prop
}

hydro_enable_soundfx_c(){
    cp -r -u "$MODPATH"/soundfx/c/odm "$MODPATH"
    cp -r -u "$MODPATH"/soundfx/c/my_product "$MODPATH"
    [ ! -f "$MODPATH/odm/etc/resourcemanager.xml" ] && cp /odm/etc/resourcemanager.xml "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<param key="oplus_check_speaker" value="true"\/>/<param key="oplus_check_speaker" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    [ -n "$dis_spkrprot" ] && sed -i 's/<param key="oplus_lvve_err_fb" value="true"\/>/<param key="oplus_lvve_err_fb" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<param key="oplus_opve_err_fb" value="true"\/>/<param key="oplus_opve_err_fb" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<param key="speaker_diff_latency_support" value ="true" \/>/<param key="speaker_diff_latency_support" value ="false" \/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<param key="power_analysis_enable" value="true"/>/<param key="power_analysis_enable" value="false"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    [ -n "$dis_spkrprot" ] && sed -i 's/<param key="speaker_ckv_extn" value="7"\/>/<param key="speaker_ckv_extn" value="0"\/>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    #[ -n "$dis_spkrprot" ] && sed -i 's/<speaker_protection_enabled>1<\/speaker_protection_enabled>/<speaker_protection_enabled>0<\/speaker_protection_enabled>/g' "$MODPATH"/odm/etc/resourcemanager.xml
    sed -i '/# Start of A-tune/,/# End of A-tune/d' "$MODPATH"/system.prop
    sed -i '/# Start of B-tune/,/# End of B-tune/d' "$MODPATH"/system.prop
}

hydro_disable_soundfx(){
    rm -rf "$MODPATH"/soundfx
    sed -i '/## Ray/,/## End of tune/d' "$MODPATH"/system.prop
    sed -i '/# Sound/,/# Sound fin./d' "$MODPATH"/post-fs-data.sh
}

hydro_dax_disable(){
    rm -rf "$MODPATH"/odm/etc/dolby/
}

hydro_dax_pure(){
    mv "$MODPATH"/odm/etc/dolby/pure.xml "$MODPATH"/odm/etc/dolby/multimedia_dolby_dax_default.xml
    rm -f "$MODPATH"/odm/etc/dolby/bass.xml
    rm -f "$MODPATH"/odm/etc/dolby/hifi.xml
}

hydro_dax_bass(){
    mv "$MODPATH"/odm/etc/dolby/bass.xml "$MODPATH"/odm/etc/dolby/multimedia_dolby_dax_default.xml
    rm -f "$MODPATH"/odm/etc/dolby/pure.xml
    rm -f "$MODPATH"/odm/etc/dolby/hifi.xml
}

hydro_dax_hifi(){
    mv "$MODPATH"/odm/etc/dolby/hifi.xml "$MODPATH"/odm/etc/dolby/multimedia_dolby_dax_default.xml
    rm -f "$MODPATH"/odm/etc/dolby/pure.xml
    rm -f "$MODPATH"/odm/etc/dolby/bass.xml
}

hydro_dax_default(){
    case $model_product in
    PHN110|CPH2551)
        mv "$MODPATH"/odm/etc/dolby/open-dax.xml "$MODPATH"/odm/etc/dolby/multimedia_dolby_dax_default.xml
        ;;
    PHK110|CPH2487)
        mv "$MODPATH"/odm/etc/dolby/ace2.xml "$MODPATH"/odm/etc/dolby/multimedia_dolby_dax_default.xml
        ;;
    esac
}

hydro_enable_raw_speaker(){
    mv "$MODPATH"/my_product/etc/raw.xml "$MODPATH"/my_product/etc/audio_policy_configuration.xml
    rm -f "$MODPATH"/my_product/etc/normal.xml
}

hydro_enable_normal_speaker(){
    mv "$MODPATH"/my_product/etc/normal.xml "$MODPATH"/my_product/etc/audio_policy_configuration.xml
    rm -f "$MODPATH"/my_product/etc/raw.xml
}

hydro_audiox_disable(){
    sed -i '/<library name="oplus_audiox_sw" path="libOplusAudioxAidl.so"\/>/d' "$MODPATH"/odm/etc/audio_effects_config.xml
    sed -i '/<library name="oppo_audiox_sw_effects" path="liboppo_audiox_sw_effects.so"\/>/d' "$MODPATH"/odm/etc/audio_effects.xml
    sed -i '/<effect name="oppo_audiox_sw_effects" library="oppo_audiox_sw_effects" uuid="41f6c0f4-5d8f-11ec-bf63-0242ac130002"\/>/d' "$MODPATH"/odm/etc/audio_effects.xml
    sed -i '/<effect name="oplusaudiox" library="oplus_audiox_sw" uuid="41f6c0f4-5d8f-11ec-bf63-0242ac130002"\/>/d' "$MODPATH"/odm/etc/audio_effects_config.xml
}

hydro_soundfx_install(){
    case $lang in
    zh)
        hydro_print "是否启用音频优化？"
        hydro_print "可绕过SRC，提供更低的延时和更高保真的音频表现"
        hydro_print "可能会导致一些问题，请自行测试"
        hydro_print "音量键 + : 启用音频优化"
        hydro_print "音量键 - : 不启用音频优化"
        ;;
    en)
        hydro_print "Choose whether to enable sound effects modification"
        hydro_print "May perform abnormally on certain scenes"
        hydro_print "Volume + : Enable sound optimization"
        hydro_print "Volume - : Disable sound optimization"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer la modification des effets sonores"
        hydro_print "Peut fonctionner anormalement sur certaines scènes"
        hydro_print "Volume + : Activer l'optimisation du son"
        hydro_print "Volume + : Désactiver l'optimisation du son"
        ;;
    esac
    while [ "$key_click_1" = "" ]; do
        key_click_1=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        case $lang in
        zh)
            hydro_print "--本功能主要由 Ray 完成开发"
            ;;
        en)
            hydro_print "--This feature is mainly developed by Ray"
            ;;
        fr)
            hydro_print "--Cette fonctionnalité est principalement développée par Ray"
            ;;
        esac
        hydro_enable_soundfx
        [ "$raw_supported" != "1" ] && hydro_raw_speaker_install
        [ "$not_ins_dolby" != "1" ] && [ "$not_choose_dax" != "1" ] && hydro_dax_install
        [ "$not_choose_dax" != "1" ] && hydro_dax_default
        [ "$not_ins_dolby" = "1" ] && hydro_audiox_install
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_soundfx
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_raw_speaker_install(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否启用低延迟（raw）音频通路？"
        hydro_print "这会导致在CPU频率过低时发生爆音"
        hydro_print "音量键 + : 启用"
        hydro_print "音量键 - : 不启用"
        ;;
    en)
        hydro_print "Choose whether to enable low latency audio path"
        hydro_print "This can cause popping noise when the CPU frequency is too low"
        hydro_print "Volume + : Enable"
        hydro_print "Volume - : By default"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer chemin audio à faible latence"
        hydro_print "Cela peut provoquer des bruits secs lorsque la fréquence du processeur est trop basse"
        hydro_print "Volume + : Activer"
        hydro_print "Volume - : Par défaut"
        ;;
    esac
    while [ "$key_click_1_4" = "" ]; do
        key_click_1_4=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1_4 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enable_raw_speaker
        ;;
    *)
        hydro_print "-- ✖"
        hydro_enable_normal_speaker
        ;;
    esac
}

hydro_audiox_install(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否禁用自研音效（OReality/AudioX）？"
        hydro_print "这会移除设备的音效支持，获得更原味的声音表现"
        hydro_print "但会导致全息音频、空间音频等亦失效"
        hydro_print "音量键 + : 禁用"
        hydro_print "音量键 - : 不禁用"
        ;;
    en)
        hydro_print "Choose whether to disable OReality Audiofx?"
        hydro_print "Your device will recover from suffering"
        hydro_print "Volume + : Disable"
        hydro_print "Volume - : By default"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez désactiver OReality Audiofx ?"
        hydro_print "Votre appareil se remettra de la souffrance"
        hydro_print "Volume + : Désactiver"
        hydro_print "Volume - : Par défaut"
        ;;
    esac
    while [ "$key_click_1_5" = "" ]; do
        key_click_1_5=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1_5 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_audiox_disable
        ;;
    *)
        hydro_print "-- ✖"
        case $lang in
        en)
            hydro_print "--What a shame, you love shit. But I will also modify your AudioX presets"
            hydro_print "--You will get a better sound quality, don't worry."
            ;;
        fr)
            hydro_print "--Quel dommage, tu aimes la merde. Mais je vais aussi modifier tes presets AudioX"
            hydro_print "--Vous obtiendrez une meilleure qualité sonore, ne vous inquiétez pas."
            ;;
        esac
        ;;
    esac
}

hydro_dax_install(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否启用杜比音效修改？"
        hydro_print "预设配置基于 GT 大师探索版/一加 Ace 3等"
        hydro_print "可能在其他设备上无法取得正常表现"
        hydro_print "音量键 + : 启用"
        hydro_print "音量键 - : 不启用"
        ;;
    en)
        hydro_print "Choose whether to enable Dolby audio modification?"
        hydro_print "The configuration is based on GT Master Edition/OnePlus Ace 3"
        hydro_print "May not perform properly on other devices"
        hydro_print "Volume + : Enable"
        hydro_print "Volume - : By default"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer la modification audio Dolby ?"
        hydro_print "La configuration est basée sur GT Master Edition/OnePlus Ace 3"
        hydro_print "Peut ne pas fonctionner correctement sur d'autres appareils"
        hydro_print "Volume + : Activer"
        hydro_print "Volume - : Par défaut"
        ;;
    esac
    while [ "$key_click_1_1" = "" ]; do
        key_click_1_1=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1_1 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_dax_install_bass
        ;;
    *)
        hydro_print "-- ✖"
        hydro_dax_disable
        ;;
    esac
}

hydro_dax_install_bass(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否启用扬声器低频增强？"
        hydro_print "d⁽⁽(ཀ д ཀ)⁾⁾b 真正的音乐"
        hydro_print "音量键 + : 启用（哦，我的上帝，你确定要这样做吗！？）"
        hydro_print "音量键 - : 不启用（选这个！）"
        ;;
    en)
        hydro_print "Choose whether to enable bass enhancement"
        hydro_print "If you prefer more bass sound like Apple, try it"
        hydro_print "Volume + : Enable bass enhancement (Not recommended)"
        hydro_print "Volume - : Disable bass enhancement (Recommended)"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non l'amélioration des bassest"
        hydro_print "Si vous préférez un son plus grave comme Apple, essayez-le"
        hydro_print "Volume + : Activer l'amélioration des basses (Non recommandé)"
        hydro_print "Volume - : Désactiver l'amélioration des basses (recommandé)"
        ;;
    esac
    while [ "$key_click_1_2" = "" ]; do
        key_click_1_2=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1_2 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_dax_bass
        ;;
    *)
        hydro_print "-- ✖"
        hydro_dax_install_pure
        ;;
    esac
}

hydro_dax_install_pure(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否启用扬声器高频增强？"
        hydro_print "～(￣▽￣～)~真正的音乐"
        hydro_print "音量键 + : 启用高频增强（Pure 版本）"
        hydro_print "音量键 - : 不启用（HiFi 版本）"
        ;;
    en)
        hydro_print "Choose whether to enable high frequency enhancement"
        hydro_print "Volume + : Enable high frequency enhancement"
        hydro_print "Volume - : Disable high frequency enhancement"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'amélioration des hautes fréquences"
        hydro_print "Volume + : Activer l'amélioration des hautes fréquences"
        hydro_print "Volume - : Désactiver l'amélioration des hautes fréquences"
        ;;
    esac
    while [ "$key_click_1_3" = "" ]; do
        key_click_1_3=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1_3 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_dax_pure
        ;;
    *)
        hydro_print "-- ✖"
        hydro_dax_hifi
        ;;
    esac
}

hydro_disable_drr(){
    sed -i '/# Refresh rate control/,/# Refresh rate control fin./d' "$MODPATH"/service.sh
    rm -f "$MODPATH/my_product/etc/oplus_vrr_config.json"
    rm -f "$MODPATH/my_product/etc/oplus_adfr_config.json"
    rm -f "$MODPATH/my_product/etc/refresh_rate_config.xml"
}

hydro_drr_opt(){
    sed -i '/# Refresh rate control/,/# Refresh rate control fin./d' "$MODPATH"/service.sh
}

hydro_enforce_drr(){
    rm -f "$MODPATH/my_product/etc/oplus_vrr_config.json"
    rm -f "$MODPATH/my_product/etc/refresh_rate_config.xml"
}

hydro_drr_install_opt(){
    case $lang in
    zh)
        hydro_print "是否启用可变刷新率优化 (VRR)"
        hydro_print "这可能会降低一些功耗，并提升流畅度"
        hydro_print "当启用单脉冲调光时，提供更好的频闪表现"
        hydro_print "此功能对于 LTPS 屏幕的设备用处不大"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to optimize valuable refresh rate (LTPO)"
        hydro_print "This function can reduce some power cost"
        hydro_print "While using single pulse mode, it might provide better eyecare experience"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez optimiser le taux de rafraîchissement dynamique (LTPO)"
        hydro_print "Cette fonction peut réduire certains coûts d'énergie"
        hydro_print "Lors de l'utilisation du mode impulsion unique, cela peut offrir une meilleure expérience de soins oculaires"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_3" = "" ]; do
        key_click_3=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_3 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_drr_opt
        ;;
    *)
        hydro_drr_install_disable
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_drr_install_disable(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "是否关闭可变刷新率 (VRR)"
        hydro_print "本功能可能会减少一些异常卡顿"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to disable dynamic refresh rate (VRR)"
        hydro_print "This function can reduce some abnormal fps decreasing"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez désactiver le taux de rafraîchissement dynamique (VRR)"
        hydro_print "Cette fonction peut réduire certaines fps anormales"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_3_2" = "" ]; do
        key_click_3_2=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_3_2 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enforce_drr
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_drr
        ;;
    esac
    sleep 0.5
}

hydro_disable_memc(){
    sed -i '/oplus.software.display.memc_enable/d' "$MODPATH"/my_product/etc/permissions/oplus.product.display_features.xml
    sed -i '/oplus.software.display.iris_enable/d' "$MODPATH"/my_product/etc/permissions/oplus.product.display_features.xml
    sed -i '/oplus.software.display.pixelworks_enable/d' "$MODPATH"/my_product/etc/permissions/oplus.product.display_features.xml
    rm -f "$MODPATH/my_product/vendor/etc/multimedia_pixelworks_apps.xml"
}

hydro_memc_install(){
    case $lang in
    zh)
        hydro_print "是否启用视频 MEMC 补帧？"
        hydro_print "这个功能可以强制启用 Color OS 的视频补帧选项，并扩展支持清单"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable video MEMC"
        hydro_print "This function can forcibly enable MEMC in Color OS settings"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer la vidéo MEMC"
        hydro_print "Cette fonction peut activer de force MEMC dans les paramètres Color OS"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_4" = "" ]; do
        key_click_4=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_4 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_memc
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_enable_irishelper(){
    return 0
}

hydro_disable_irishelper(){
    rm -rf "$MODPATH"/iris
    sed -i '/# Iris Helper by AB/,/# Iris Helper by AB fin./d' "$MODPATH"/service.sh
}

hydro_iris_install(){
    case $lang in
    zh)
        hydro_print "是否启用 Iris Helper?"
        hydro_print "该功能能够自定义包括 MEMC、HDR 在内的一些显示参数"
        hydro_print "一加 Ace 3/Pro不建议启用此功能"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable Iris Helper"
        hydro_print "This function can customize some display parameters including MEMC and HDR"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer Iris Helper"
        hydro_print "Cette fonction permet de personnaliser certains paramètres d'affichage dont MEMC et HDR"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_5" = "" ]; do
        key_click_5=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_5 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        case $lang in
        zh)
            hydro_print "--注意！你必须将每一个你需要启用 X7 功能的 App 列入配置文件！"
            hydro_print "--未在配置文件内的 App 均会被禁用 X7 相关功能"
            hydro_print "--配置文件和使用说明在 /data/adb/modules/ab_optimizer/iris 内"
            ;;
        en)
            hydro_print "--Attention! You have to list every single app which needs MEMC in configuration file!"
            hydro_print "--Apps that are not included in the configuration file will have X7 related functions disabled"
            hydro_print "--The configuration file is in /data/adb/modules/ab_optimizer/iris"
            ;;
        fr)
            hydro_print "--Attention! Vous devez lister chaque application qui a besoin de MEMC dans le fichier de configuration !"
            hydro_print "--Les applications qui ne sont pas incluses dans le fichier de configuration auront les fonctions liées à X7 désactivées"
            hydro_print "--Le fichier de configuration est dans /data/adb/modules/ab_optimizer/iris"
            ;;
        esac
        hydro_enable_irishelper
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_irishelper
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_memopt(){
    sed -i '/# MEM opt/,/# MEM opt fin./d' "$MODPATH"/assets/functions.sh
    sed -i '/# ZRAM opt/,/# ZRAM opt fin./d' "$MODPATH"/assets/functions.sh
    sed -i '/# MEM opt/,/# MEM opt fin./d' "$MODPATH"/system.prop
}

hydro_memopt_install(){
    case $lang in
    zh)
        hydro_print "是否启用内存管理优化？"
        hydro_print "显著提升复杂场景下的进程存活能力，减少冷启动以降低功耗"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable memory management optimization"
        hydro_print "Significantly improve process survivability in complex scenarios"
        hydro_print "Reduces cold starts so battery life is extended"
        hydro_print "This feature conflicts with any memory management module"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation de la gestion de la mémoire"
        hydro_print "Améliorer considérablement la capacité de survie des processus dans des scénarios complexes"
        hydro_print "Réduit les démarrages à froid pour prolonger la durée de vie de la batterie"
        hydro_print "Cette fonctionnalité est en conflit avec n'importe quel module de gestion de mémoire"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_6" = "" ]; do
        key_click_6=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_6 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_memopt
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_enable_brightness_enhance(){
    [ -z "$ins_comf_brightness" ] && sed -i '/<comfortable_brightness>/,/<\/comfortable_brightness>/d' "$MODPATH"/my_product/vendor/etc/display_brightness_app_list.xml
}

hydro_disable_brightness_enhance(){
    cp -f "$MODPATH/my_product/vendor/etc/multimedia_pixelworks_game_apps.xml" "$TMPDIR"
    cp -r -f "$MODPATH"/disp_ori/etc "$MODPATH"/my_product/vendor
    cp -f "$TMPDIR/multimedia_pixelworks_game_apps.xml" "$MODPATH/my_product/vendor/etc"
    sed -i '/# Brightness new/,/# Brightness new fin./d' $MODPATH/post-fs-data.sh
    [ -z "$ins_comf_brightness" ] && sed -i '/<comfortable_brightness>/,/<\/comfortable_brightness>/d' "$MODPATH"/my_product/vendor/etc/display_brightness_app_list.xml
}

hydro_brightness_enhance_install(){
    case $lang in
    zh)
        hydro_print "是否启用亮度优化？"
        hydro_print "启用后，手动全屏亮度可以达到 2160nits~800nits，取决于你的设备"
        hydro_print "同时，通过优化自动亮度和相关策略，提升设备场景表现"
        hydro_print "音量键 + : 开启手动亮度增强"
        hydro_print "音量键 - : 关闭手动亮度增强"
        ;;
    en)
        hydro_print "Choose whether to enable maximum manual brightness extension"
        hydro_print "The maximum brightness can reach 2160nits~800nits, depending on your device"
        hydro_print "This may cause minimum brightness of some devices to be 0"
        hydro_print "Volume + : Enable maximum manual brightness extension"
        hydro_print "Volume - : Disable maximum manual brightness extension"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non l'extension manuelle maximale de la luminosité"
        hydro_print "La luminosité maximale peut atteindre 2160 nits ~ 800 nits, selon votre appareil"
        hydro_print "Cela peut entraîner une luminosité minimale de certains appareils à 0"
        hydro_print "Volume + : Activer l'extension manuelle maximale de la luminosité"
        hydro_print "Volume - : Désactiver l'extension manuelle maximale de la luminosité"
        ;;
    esac
    while [ "$key_click_7" = "" ]; do
        key_click_7=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_7 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enable_brightness_enhance
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_brightness_enhance
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_pxlw_enhance(){
    rm -f "$MODPATH/odm/etc/iris_configs.xml"
    [ -f "$MODPATH/disp_ori/etc/multimedia_pixelworks_game_apps.xml" ] && cp "$MODPATH/disp_ori/etc/multimedia_pixelworks_game_apps.xml" "$MODPATH/my_product/vendor/etc"
}

hydro_pxlw_enhance_install(){
    case $lang in
    zh)
        hydro_print "是否启用 Pixelworks X7/X7 Gen 2 优化？"
        hydro_print "在保证延迟的前提下，显著优化游戏的超帧超分效果"
        hydro_print "并为 Iris Helper 提供更多的可用预设"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable Pixelworks X7/X7 Gen 2 optimization"
        hydro_print "This function optimizes MEMC and super-resolution effects of some games"
        hydro_print "Provide more available presets for Iris Helper in addition"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation Pixelworks X7/X7 Gen 2"
        hydro_print "Cette fonction optimise les effets MEMC et super-résolution de certains jeux"
        hydro_print "Fournir davantage de préréglages disponibles pour Iris Helper"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_8" = "" ]; do
        key_click_8=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_8 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_pxlw_enhance
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_vibration(){
    sed -i '/# Vibration enhancement/,/# Vibration enhancement fin./d' "$MODPATH"/assets/functions.sh
}

hydro_vibration_install(){
    case $lang in
    zh)
        hydro_print "是否启用振动强度增强?"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable vibration enhancement"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non l'amélioration des vibrations"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_9" = "" ]; do
        key_click_9=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_9 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_vibration
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_vulkan(){
    sed -i 's/"vulkanFlag": 1/"vulkanFlag": 0/' "$MODPATH"/assets/hardware_model_config.json
}

hydro_ysvk_install(){
    case $lang in
    zh)
        hydro_print "是否强行启用原神的 Vulkan 支持？"
        hydro_print "这会显著降低原神的性能需求"
        hydro_print "提供更长的续航、更低的温度和更平滑的画面表现"
        sleep 0.2
        hydro_print "但会在少数场景显示异常，并需要重新预载着色器"
        hydro_print "亦会导致游戏助手修改分辨率的手段失效"
        hydro_print "音量键 + : 使用 Vulkan"
        hydro_print "音量键 - : 使用 OpenGL(默认)"
        ;;
    en)
        hydro_print "Choose whether to forcibly enable Genshin Impact's Vulkan support"
        hydro_print "This will significantly improve the performance"
        hydro_print "Provides longer battery life, lower temperature and smoother frame rate"
        sleep 0.2
        hydro_print "Will display exceptions in a few scenes and the shader needs to be reloaded"
        hydro_print "Volume + : Use Vulkan"
        hydro_print "Volume - : Use OpenGL"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non de force le support Vulkan de Genshin Impact"
        hydro_print "Cela améliorera considérablement les performances"
        hydro_print "Offre une durée de vie de la batterie plus longue,"
        sleep 0.2
        hydro_print "une température plus basse et une fréquence d'images plus fluide"
        hydro_print "Affichera les exceptions dans quelques scènes et le shader devra être rechargé"
        hydro_print "Volume + : Utiliser Vulkan"
        hydro_print "Volume - : Utiliser OpenGL"
        ;;
    esac
    while [ "$key_click_10" = "" ]; do
        key_click_10=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_10 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        case $lang in
        zh)
            hydro_print "将 /data/adb/modules/ab_optimizer/assets/ 内的文件"
            hydro_print "手动复制进对应目录以确保其生效"
            ;;
        en)
            hydro_print "Put the files in /data/adb/modules/ab_optimizer/assets/"
            hydro_print "Manually into the corresponding game directory to ensure it takes effect"
            ;;
        fr)
            hydro_print "Placez les fichiers dans /data/adb/modules/ab_optimizer/assets/"
            hydro_print "Manuellement dans le répertoire du jeu correspondant pour garantir qu'il prend effet"
            ;;
        esac
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_vulkan
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_enable_camera(){
    if [ $ins_camera="ace3" ]; then
        return 0
    else
        sed -i '/# Cam Ace 3/,/# Cam Ace 3 fin./d' "$MODPATH/post-fs-data.sh"
    fi
}

hydro_disable_camera(){
    sed -i '/# Camera/,/# Camera fin./d' "$MODPATH/post-fs-data.sh"
    rm -rf "$MODPATH/odm/etc/camera"
}

hydro_camera_install(){
    case $lang in
    zh)
        hydro_print "是否启用影像优化?"
        hydro_print "启用影像联名功能，启用原生未支持的功能"
        hydro_print "并调整部分参数以优化成片效果"
        hydro_print "注意！可能无法在 Magisk 下正常工作！"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable camera enhancement?"
        hydro_print "Enable Ha**elb**d related functions and other disabled features by default"
        hydro_print "Optimize parameters for a better pitcure at the same time"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non l'amélioration de la caméra ?"
        hydro_print "Activer les fonctions liées à Ha**elb**d et autres fonctionnalités désactivées par défaut"
        hydro_print "Optimiser les paramètres pour une meilleure image en même temps"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_11" = "" ]; do
        key_click_11=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_11 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enable_camera
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_camera
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_perfopt_affinityset(){
    if [ "$ins_affinityopt" = "1" -a -d "/data/adb/modules/asoul_affinity_opt" ]; then
        mv "$MODPATH"/assets/vendor.oplus.hardware.gameopt-service "$MODPATH"/odm/bin/hw/
        mv "$MODPATH"/assets/vendor.oplus.hardware.ormsHalService-aidl-service "$MODPATH"/odm/bin/hw/
        case $lang in
        zh)
            hydro_print "--检测到已安装 A-SOUL Opt 模块"
            hydro_print "--自动为您禁用 gameopt 以解决亲和性异常问题"
            ;;
        en)
            hydro_print "--A-SOUL Opt module detected"
            hydro_print "--Automatically disabled Gameopt service for you to solve the affinity anomaly problem"
            ;;
        fr)
            hydro_print "--A-SOUL Opt module détecté"
            hydro_print "--Activez automatiquement Gameopt modifiés pour que vous puissiez résoudre le problème d'anomalie d'affinité"
            ;;
        esac
    else
        sed -i '/# Affinity adjustment/,/# Affinity adjustment fin./d' "$MODPATH"/post-fs-data.sh
    fi
}

hydro_enable_perfopt(){
    mkdir -p "$MODPATH"/odm/bin/hw
    hydro_perfopt_affinityset
}

hydro_disable_perfopt(){
    sed -i '/## Perf Opt/,/## Perf Opt fin./d' "$MODPATH"/system.prop
    sed -i '/# Performance adjustment/,/# Performance adjustment fin./d' "$MODPATH/assets/functions.sh"
    sed -i '/# Performance adjustment/,/# Performance adjustment fin./d' "$MODPATH/post-fs-data.sh"
}

hydro_perfopt_install(){
    case $lang in
    zh)
        hydro_print "是否启用设备效能优化?"
        hydro_print "调整 cpuset, uag/walt, corectl, kgsl等"
        hydro_print "以实现更优秀的综合表现"
        hydro_print "启用本功能后，推荐您使用其他第三方调度以获得更佳的游戏表现"
        hydro_print "本功能暂不对 SM8750 平台进行过多调整"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable device performance optimization"
        hydro_print "Adjust cpuset, cpufreq efficiency, shell temp, corectl, kgsl, etc."
        hydro_print "In order to achieve better overall performance"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation des performances de l'appareil"
        hydro_print "Ajustez cpuset, efficacité cpufreq, température du shell, corectl, kgsl, etc."
        hydro_print "Afin d'obtenir de meilleures performances globales"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_2" = "" ]; do
        key_click_2=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_2 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        hydro_enable_perfopt
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_perfopt
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_general_prompt(){
    case $lang in
    zh)
        hydro_print "除以上功能外，另有一些默认启用的功能"
        sleep 0.2
        hydro_print "能够降低部分场景的功耗，提高设备运行效率"
        hydro_print "这可能与某些\"调度\"模块冲突，请注意"
        ;;
    en)
        hydro_print "There are also some functions enabled by default"
        sleep  0.2
        hydro_print "Reduce power consumption and improve efficiency"
        hydro_print "These functions do not conflict with any known modules"
        ;;
    fr)
        hydro_print "Certaines fonctions sont également activées par défaut"
        sleep 0.2
        hydro_print "Réduire la consommation d'énergie et améliorer l'efficacité"
        hydro_print "Ces fonctions n'entrent en conflit avec aucun module connu"
        ;;
    esac
    sleep 0.7
    print_line
}

hydro_install_completed(){
    case $lang in
    zh)
        hydro_print "安装完成"
        hydro_print "请确保你已经阅读了以上全部的安装提示"
        sleep 0.2
        hydro_print "现在，尽情欢呼吧！"
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    en)
        hydro_print "Installation completed"
        hydro_print "Please ensure that you have been aware of the above precautions"
        hydro_print "Feedback and bug report via 981916119@qq.com"
        sleep 0.2
        hydro_print "Or join OnePlus Fan Group https://t.me/hydrostellaire"
        sleep 0.2
        hydro_print "Now, you will rejoice this! "
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    fr)
        hydro_print "installation terminée"
        hydro_print "Veuillez vous assurer que vous avez pris connaissance des précautions ci-dessus"
        hydro_print "Commentaires et rapport de bug via https://t.me/hydrostellaire"
        sleep 0.2
        hydro_print "Maintenant, vous vous en réjouirez !"
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    esac
}

hydro_settings_backup(){
    touch "$MODPATH"/settings.txt
    {
       echo "model:$model_product" 
       echo "0:$key_click_0"
       echo "1:$key_click_1"
       echo "1_1:$key_click_1_1"
       echo "1_2:$key_click_1_2"
       echo "1_3:$key_click_1_3"
       echo "1_4:$key_click_1_4"
       echo "1_5:$key_click_1_5"
       echo "2:$key_click_2"
       echo "3:$key_click_3"
       echo "3_2:$key_click_3_2"
       echo "4:$key_click_4"
       echo "5:$key_click_5"
       echo "6:$key_click_6"
       echo "7:$key_click_7"
       echo "8:$key_click_8"
       echo "9:$key_click_9"
       echo "10:$key_click_10"
       echo "11:$key_click_11"
       echo "en:$key_click_en"
       echo "fr:$key_click_fr"
       echo "}"
    } >> $settings
}

hydro_read_settings(){
    while read -r lineP; do
        case "$lineP" in
        device:*)
           param=${lineP#device:}
           device=$param
           ;;
        model:*)
           param=${lineP#model:}
           model_product=$param
           ;;
        0:*)
           param=${lineP#0:}
           key_click_0=$param
           ;;
        1:*)
           param=${lineP#1:}
           key_click_1=$param
           ;;
        1_1:*)
           param=${lineP#1_1:}
           key_click_1_1=$param
           ;;
        1_2:*)
           param=${lineP#1_2:}
           key_click_1_2=$param
           ;;
        1_3:*)
           param=${lineP#1_3:}
           key_click_1_3=$param
           ;;
        1_4:*)
           param=${lineP#1_4:}
           key_click_1_4=$param
           ;;
        1_5:*)
           param=${lineP#1_5:}
           key_click_1_5=$param
           ;;
        2:*)
           param=${lineP#2:}
           key_click_2=$param
           ;;
        3:*)
           param=${lineP#3:}
           key_click_3=$param
           ;;
        3_2:*)
           param=${lineP#3_2:}
           key_click_3_2=$param
           ;;
        4:*)
           param=${lineP#4:}
           key_click_4=$param
           ;;
        5:*)
           param=${lineP#5:}
           key_click_5=$param
           ;;
        6:*)
           param=${lineP#6:}
           key_click_6=$param
           ;;
        7:*)
           param=${lineP#7:}
           key_click_7=$param
           ;;
        8:*)
           param=${lineP#8:}
           key_click_8=$param
           ;;
        9:*)
           param=${lineP#9:}
           key_click_9=$param
           ;;
        10:*)
           param=${lineP#10:}
           key_click_10=$param
           ;;
        11:*)
           param=${lineP#11:}
           key_click_11=$param
           ;;
        en:*)
           param=${lineP#en:}
           key_click_en=$param
           ;;
        fr:*)
           param=${lineP#fr:}
           key_click_fr=$param
           ;;
        "}")
           break
           ;;
        esac
    done < $settings_old
}

hydro_apply_settings(){
    case $key_click_0 in
    KEY_VOLUMEUP)
        hydro_print "--Renderer optimization enabled"
        hydro_enable_sfopt
        ;;
    *)
        hydro_print "--Renderer optimization disabled"
        hydro_disable_sfopt
        ;;
    esac
    case $key_click_1 in
    KEY_VOLUMEUP)
        hydro_print "--Sound optimization activated"
        hydro_enable_soundfx
        case $key_click_1_4 in
        KEY_VOLUMEUP)
            hydro_print "--Audio raw route activated"
            hydro_enable_raw_speaker
            ;;
        *)
            hydro_print "--Audio raw route deactivated"
            hydro_enable_normal_speaker
            ;;
        esac
        case $key_click_1_1 in
        KEY_VOLUMEDOWN)
            hydro_print "--Dolby soundfx optimization deactivated"
            hydro_dax_disable
            ;;
        *)
            if [ "$not_choose_dax" = "1" ]; then
                hydro_dax_default
                hydro_print "--Dolby soundfx optimization activated"
            else
                case $key_click_1_2 in
                KEY_VOLUMEUP)
                    hydro_print "--Bass enhancement activated"
                    hydro_dax_bass
                    ;;
                *)
                    case $key_click_1_3 in
                    KEY_VOLUMEUP)
                        hydro_print "--High frequency enhancement activated"
                        hydro_dax_pure
                        ;;
                    *)
                        hydro_print "--HiFi style activated"
                        hydro_dax_hifi
                        ;;
                    esac
                    ;;
                esac
            fi
            ;;
        esac
        case $key_click_1_5 in
        KEY_VOLUMEUP)
            hydro_print "--OPlus AudioX removed"
            hydro_audiox_disable
            ;;
        *)
            hydro_print "--OPlus AudioX modification enabled"
            ;;
        esac
        ;;
    *)
        hydro_print "--Sound optimization deactivated"
        hydro_disable_soundfx
        ;;
    esac
    case $key_click_2 in
    KEY_VOLUMEDOWN)
        hydro_print "--Device performance optimization deactivated"
        hydro_disable_perfopt
        ;;
    *)
        hydro_print "--Device performance optimization activated"
        hydro_enable_perfopt
        ;;
    esac
    case $key_click_3 in
    KEY_VOLUMEUP)
        hydro_print "--DRR modified"
        hydro_drr_opt
        ;;
    *)
        case $key_click_3_2 in
            KEY_VOLUMEUP)
                hydro_print "--DRR disabled"
                hydro_enforce_drr
                ;;
            *)
                hydro_print "--DRR by default"
                hydro_disable_drr
                ;;
        esac
        ;;
    esac
    case $key_click_4 in
    KEY_VOLUMEUP)
        hydro_print "--Video MEMC option activated"
        ;;
    *)
        hydro_print "--Video MEMC option deactivated"
        hydro_disable_memc
        ;;
    esac
    case $key_click_5 in
    KEY_VOLUMEUP)
        hydro_print "--Iris helper activated"
        hydro_enable_irishelper
        ;;
    *)
        hydro_print "--Iris helper deactivated"
        hydro_disable_irishelper
        ;;
    esac
    case $key_click_6 in
    KEY_VOLUMEDOWN)
        hydro_print "--MEM Opt deactivated"
        hydro_disable_memopt
        ;;
    *)
        if [ $is_pandora = "0" ]; then
            hydro_print "--MEM Opt activated"
        else
            hydro_print "--MEM Opt deactivated"
            hydro_disable_memopt
        fi
        ;; 
    esac
    case $key_click_7 in
    KEY_VOLUMEDOWN)
        hydro_print "--Maximum manual brightness extension deactivated"
        hydro_disable_brightness_enhance
        ;;
    *)
        hydro_print "--Maximum manual brightness extension activated"
        hydro_enable_brightness_enhance
        ;;
    esac
    case $key_click_8 in
    KEY_VOLUMEDOWN)
        hydro_print "--Iris X7/X7P enhancement deactivated"
        hydro_disable_pxlw_enhance
        ;;
    *)
        hydro_print "--Iris X7/X7P enhancement activated"
        ;;
    esac
    case $key_click_9 in
    KEY_VOLUMEDOWN)
        hydro_print "--Vibration enhancement deactivated"
        hydro_disable_vibration
        ;;
    *)
        if [ -z "$not_ins_vibration" ]; then
            hydro_print "--Vibration enhancement activated"
        else
            hydro_print "--Vibration enhancement deactivated"
            hydro_disable_vibration
        fi
        ;;
    esac
    case $key_click_10 in
    KEY_VOLUMEUP)
        hydro_print "--Vulkan for Genshin activated"
        ;;
    *)
        hydro_print "--Vulkan for Genshin deactivated"
        hydro_disable_vulkan
        ;;
    esac
    if [ $android_ver -lt 15 ]; then
        case $key_click_11 in
        KEY_VOLUMEUP)
            hydro_print "--Camera enhancement activated"
            hydro_enable_camera
            ;;
        *)
            hydro_print "--Camera enhancement deactivated"
            hydro_disable_camera
            ;;
        esac
    else
        hydro_print "--Camera enhancement deactivated"
        hydro_disable_camera
    fi
    case $key_click_en in
    KEY_VOLUMEUP)
        sed -i "s/^description=.*$/description=$DESC_ZH/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    *)
        case $key_click_fr in
        KEY_VOLUMEUP)
            sed -i "s/^description=.*$/description=$DESC_FR/" "$HYPROP"
            rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
            rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
            sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
            rm -f "$MODPATH"/请读我.md
            rm -f "$MODPATH"/README.md
            ;;
        *)
            sed -i "s/^description=.*$/description=$DESC_EN/" "$HYPROP"
            rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
            rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
            sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
            rm -f "$MODPATH"/请读我.md
            rm -f "$MODPATH"/Lis-moi.md
            ;;
        esac
    esac
    hydro_post_install
}

hydro_pre_install(){
    hydro_iris_cfg_update
}

hydro_post_install(){
    rm -rf "$MODPATH"/disp_ori
    if [ $is_pandora != "0" ]; then
        sed -i "/## From Yuni Kernel/,/## From Yuni Kernel fin./d" "$MODPATH"/system.prop
    fi
    if [ "$os_ver_ex" = "1" ]; then
        rm -rf "$MODPATH"/my_product/etc/extension
        rm -rf "$MODPATH"/my_product/etc/permissions
    fi
    set_perm_recursive "$MODPATH"/my_product/etc 0 0 0755 0644 u:object_r:system_file:s0
    set_perm_recursive "$MODPATH"/my_product/media 0 0 0755 0644 u:object_r:system_file:s0
    set_perm_recursive "$MODPATH"/my_product/vendor/etc 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/odm/etc 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/odm/firmware 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/odm/etc/camera/config 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/system/vendor/etc 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/my_product/lib64 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/odm/lib 0 0 0755 0644 u:object_r:vendor_configs_file:s0
    set_perm_recursive "$MODPATH"/odm/lib64 0 0 0755 0644 u:object_r:vendor_configs_file:s0
}

hydro_start_install(){
    key_click_0=""
    key_click_1=""
    key_click_1_1=""
    key_click_1_2=""
    key_click_1_3=""
    key_click_1_4=""
    key_click_1_5=""
    key_click_2=""
    key_click_3=""
    key_click_3_2=""
    key_click_4=""
    key_click_5=""
    key_click_6=""
    key_click_7=""
    key_click_8=""
    key_click_9=""
    key_click_10=""
    key_click_11=""
    key_click_en=""
    key_click_fr=""
    hydro_language_select
    hydro_cure_select
    hydro_model_detect
    hydro_kernel_version
    hydro_unzip_model
    if [ -z "$not_ins_sfopt" ]; then
        hydro_sfopt_install #0
    else
        key_click_0="KEY_VOLUMEDOWN"
    fi
    if [ -z "$not_ins_soundfx" ]; then
        hydro_soundfx_install #1, 1_1, 1_2, 1_3, 1_4, 1_5
    else
        key_click_1="KEY_VOLUMEDOWN"
        hydro_disable_soundfx
    fi
    if [ "$ins_camera" ] && [ $android_ver -lt 15 ]; then
        hydro_camera_install #11
    else
        key_click_11="KEY_VOLUMEDOWN"
        hydro_disable_camera
    fi
    if [ -z "$not_ins_vibration" ]; then
        hydro_vibration_install #9
    else
        key_click_9="KEY_VOLUMEDOWN"
        hydro_disable_vibration
    fi
    if [ "$is_pandora" = "0" -a "$not_ins_memopt" != "1" ]; then
        hydro_memopt_install #6
    else
        key_click_6="KEY_VOLUMEDOWN"
        hydro_disable_memopt
    fi
    hydro_perfopt_install #2
    hydro_brightness_enhance_install #7
    hydro_drr_install_opt #3, 3_2
    if [ "$has_iris" != "0" ]; then
        hydro_memc_install #4
        hydro_iris_install #5
        hydro_pxlw_enhance_install #8
    else
        key_click_4="KEY_VOLUMEDOWN"
        hydro_disable_memc
        key_click_5="KEY_VOLUMEDOWN"
        hydro_disable_irishelper
        key_click_8="KEY_VOLUMEDOWN"
        hydro_disable_pxlw_enhance
    fi
    if pm list packages | grep -q '^package:com.miHoYo.'; then
        hydro_ysvk_install #10
    fi
    hydro_general_prompt
    hydro_install_completed
    hydro_settings_backup
    hydro_post_install
}





if [ -f "/data/adb/modules/ab_optimizer/settings.txt" ]; then
    hydro_read_settings
    old_settings_apply_go="1"
elif [ -f "/data/adb/modules_update/ab_optimizer/settings.txt" ]; then
    settings_old=/data/adb/modules_update/ab_optimizer/settings.txt
    hydro_read_settings
    old_settings_apply_go="1"
else
    old_settings_apply_go="0"
fi

if [ "$device" != "" ]; then
    old_settings_apply_go="0"
fi

if [ "$old_settings_apply_go" = 1 ]; then
    case $key_click_en in
    KEY_VOLUMEUP)
        lang="zh"
        ;;
    *)
        case $key_click_fr in
        KEY_VOLUMEUP)
            lang="fr"
            ;;
        *)
            lang="en"
            ;;
        esac
    esac
    case $lang in
    zh)
        print_line
        hydro_print "检测到本模块的旧有配置"
        hydro_print "是否一键调用？"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    fr)
        print_line
        hydro_print "Une configuration existante a été détectée"
        hydro_print "Voulez-vous l'appliquer en un clic?"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/README.md
        ;;
    *)
        lang="en"
        print_line
        hydro_print "An existing configuration has been detected"
        hydro_print "Do you want to apply it with one click?"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    esac
    if [ "$hydro_old_flag" != "1" ]; then
        while [ "$key_click_a" = "" ]; do
            key_click_a=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
            sleep 0.2
        done
        sleep 0.3
        print_line
        case $key_click_a in
        KEY_VOLUMEUP)
            hydro_pre_install
            hydro_model_detect
            hydro_kernel_version
            hydro_unzip_model
            hydro_cure_select
            hydro_apply_settings
            cp $settings_old /data/adb/modules_update/ab_optimizer
            ;;
        *)
            hydro_print "--Reinstall"
            sleep 0.3
            reinstall_flag=1
            hydro_pre_install
            hydro_start_install
            ;;
        esac
    fi
else
    hydro_start_install
fi