set_perm_recursive "$MODPATH"/assets 0 0 0755 0644 u:object_r:system_file:s0
set_perm_recursive "$MODPATH"/iris 0 0 0755 0644 u:object_r:system_file:s0
chcon u:object_r:lmkd_exec:s0 "$MODPATH/system/bin/lmkd"
chcon -R "u:object_r:vendor_configs_file:s0" "$MODPATH/system/vendor/etc/"
chown root:shell "$MODPATH/system/bin/lmkd"
chmod 755 "$MODPATH/system/bin/lmkd"
set_perm "$MODPATH"/iris/iris_helper 0 0 0755

android_version=$(getprop ro.system.build.version.release)
soc=$(getprop ro.hardware)
model=$(getprop ro.product.model)
device=$(getprop ro.product.board)
marketname=$(getprop ro.product.marketname)
manufacturer=$(getprop ro.product.system.manufacturer)
kernel_version=$(uname -r)
settings="$MODPATH"/settings.txt
settings_old=/data/adb/modules/ab_optimizer/settings.txt
HYPROP="$MODPATH"/module.prop
hydro_version=$(grep_prop version "$HYPROP")
hydro_versionCode=$(grep_prop versionCode "$HYPROP")
DESC_ZH="赐予新生！为 $marketname！"
DESC_EN="Bestow a rebirth upon $marketname\."
DESC_FR="Accordez une renaissance à $marketname\."

hydro_print(){
    sleep 0.05
    ui_print "$1"
}

hydro_abort(){
    ui_print ""
    ui_print ""
    ui_print ""
    abort
}

print_line(){
    hydro_print "——————————"
}

hydro_language_select(){
    hydro_print "请选择您的语言/Choose your language/Choisissez votre langue"
    hydro_print "音量键 + : 简体中文"
    hydro_print "Volume - : English/Français"
    while [ "$key_click_en" = "" ]; do
        key_click_en=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_en in
    KEY_VOLUMEUP)
        hydro_print "--已选择语言: 简体中文"
        lang="zh"
        sed -i "s/^description=.*$/description=$DESC_ZH/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    *)
        hydro_language_choose_fr_en
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_language_choose_fr_en(){
    hydro_print "Volume + : Français"
    hydro_print "Volume - : English"
    while [ "$key_click_fr" = "" ]; do
        key_click_fr=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_fr in
    KEY_VOLUMEUP)
        hydro_print "--Langue actuelle : Français"
        lang="fr"
        sed -i "s/^description=.*$/description=$DESC_FR/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/README.md
        ;;
    *)
        hydro_print "--Current language: English"
        lang="en"
        sed -i "s/^description=.*$/description=$DESC_EN/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    esac
}

hydro_kernel_version(){
    if [[ $kernel_version == *"Yuni"* ]]; then
        h_yuni_kernel=1
    else
        if [[ $kernel_version == *"AngelBeats"* ]]; then
            h_yuni_kernel=2
        else
            if [[ $kernel_version == *"Pandora"* ]]; then
                h_yuni_kernel=3
            else
                h_yuni_kernel=0
            fi
        fi
    fi
    if [ -f "/data/adb/modules/pandora_kernel/remove" -o -f "/data/adb/modules/yuni_kernel/remove" -o -f "/data/adb/modules/angelbeats_kernel/remove" ]; then
        h_yuni_kernel=0
    fi
    if [[ $h_yuni_kernel -gt 0 ]]; then
        is_pandora=1
    else
        is_pandora=0
    fi
}

hydro_pandora_beta(){
    hydro_kernel_version
    case $kernel_version in
    ????????*)
        last_eight=${kernel_version#${kernel_version%????????}}
        ;;
    *)
        last_eight=$kernel_version
        ;;
    esac
    if [ $is_pandora = 1 ]; then
        if [[ "$(expr index "$last_eight" '[a-z]')" -eq 0 ]]; then
            pandora_is_beta=1
            pandora_beta_version=${kernel_version: -8}
        else
            pandora_is_beta=0
            pandora_open_version=${kernel_version: -1}
        fi
    else
        cloud_mode=2
    fi
    
    if [[ $pandora_beta_version -ge 20240121 ]]; then
        cloud_mode=2
    else
        if [[ $pandora_open_version -ge 2 ]]; then
            cloud_mode=2
        else
            cloud_mode=1
        fi
    fi
}

hydro_cloud_process_new(){
    hydro_pandora_beta
}

hydro_official_kernel(){
    sed -i 's/perfmgr_mtk/mtk_fpsgo/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/target_fps_48/t_fps_49/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/target_fps_60/t_fps_61/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/target_fps_90/t_fps_91/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/target_fps_120/t_fps_121/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/fixed_target_fps/f_t_fps/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/normal_frame_keep_count/nor_f_keep/g' "$MODPATH"/joy_config/booster_config_mtk.json
}

hydro_yuni_kernel(){
    sed -i -r 's/^[^#].*(cpufreq_debug|custom_upbound_gpu_freq|dcs_mode|core_ctl|ultra_rescue|gpufreqv2)/#&/g' /data/adb/modules/yuni_kernel/service.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules/yuni_kernel/system.prop
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules/yuni_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules/yuni_kernel/config
    cp "$MODPATH"/system/vendor/etc/powercontable.xml /data/adb/modules/yuni_kernel/system/vendor/etc/powercontable.xml
}

hydro_ab_kernel(){
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules/angelbeats_kernel/system.prop
    sed -i 's/perfmgr_mtk/mtk_fpsgo/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/fixed_target_fps/f_t_fps/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/perfmgr_mtk\/parameters\/ddrfreq_remap_table/mtk_fpsgo\/parameters\/ddrfreq_remap_table/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i -r 's/^[^#].*(cpufreq_debug|custom_upbound_gpu_freq|dcs_mode|ultra_rescue|gpufreqv2)/#&/g' /data/adb/modules/angelbeats_kernel/service.sh
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules/angelbeats_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules/angelbeats_kernel/config
}

hydro_pandora_kernel(){
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules/pandora_kernel/system.prop
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules/pandora_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules/pandora_kernel/config
    cp "$MODPATH"/system/vendor/etc/powercontable.xml /data/adb/modules/pandora_kernel/system/vendor/etc/powercontable.xml
}

hydro_yuni_update(){
    hydro_update_flag=1
    sed -i -r 's/^[^#].*(cpufreq_debug|custom_upbound_gpu_freq|dcs_mode|core_ctl|ultra_rescue|gpufreqv2)/#&/g' /data/adb/modules_update/yuni_kernel/service.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules_update/yuni_kernel/system.prop
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules_update/yuni_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules_update/yuni_kernel/config
    cp "$MODPATH"/system/vendor/etc/powercontable.xml /data/adb/modules_update/yuni_kernel/system/vendor/etc/powercontable.xml
}

hydro_ab_update(){
    hydro_update_flag=1
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules_update/angelbeats_kernel/system.prop
    sed -i 's/perfmgr_mtk/mtk_fpsgo/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/fixed_target_fps/f_t_fps/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i 's/perfmgr_mtk\/parameters\/ddrfreq_remap_table/mtk_fpsgo\/parameters\/ddrfreq_remap_table/g' "$MODPATH"/joy_config/booster_config_mtk.json
    sed -i -r 's/^[^#].*(cpufreq_debug|custom_upbound_gpu_freq|dcs_mode|ultra_rescue|gpufreqv2)/#&/g' /data/adb/modules_update/angelbeats_kernel/service.sh
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules_update/angelbeats_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules_update/angelbeats_kernel/config
}

hydro_pandora_update(){
    hydro_update_flag=1
    sed -i '/# GKI modification/,/# GKI modification fin./d' "$MODPATH"/functions.sh
    sed -i -r '/idle_timer|refresh_rate|content_detection|enable_frame_rate/d' /data/adb/modules_update/pandora_kernel/system.prop
    cp "$MODPATH"/joy_config/booster_config_mtk.json /data/adb/modules_update/pandora_kernel/config
    cp "$MODPATH"/joy_config/common_config.json /data/adb/modules_update/pandora_kernel/config
    cp "$MODPATH"/system/vendor/etc/powercontable.xml /data/adb/modules_update/pandora_kernel/system/vendor/etc/powercontable.xml
}

hydro_6989(){
    cp -r "$MODPATH"/platform_config/c/etc "$TMPDIR"
    cp -r "$MODPATH"/platform_config/c/power_config/etc "$MODPATH"/system/vendor
    cp "$MODPATH"/platform_config/c/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
}

hydro_6985(){
    cp -r "$MODPATH"/platform_config/a/corot/etc "$TMPDIR"
    cp -r "$MODPATH"/platform_config/a/corot/alternative "$TMPDIR"
    cp -r "$MODPATH"/platform_config/a/corot/gnss "$MODPATH"/system/vendor/etc
    mkdir -p "$MODPATH"/system/product/etc
    #cp -r "$MODPATH"/platform_config/a/corot/device_features "$MODPATH"/system/product/etc
    cp -r "$MODPATH"/platform_config/a/power_config/etc "$MODPATH"/system/vendor
    cp "$MODPATH"/platform_config/a/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
    if [ "$cloud_mode" = "2" ]; then
        cp -r "$MODPATH"/platform_config/a/corot/kernel_modules "$MODPATH"
    fi
}

hydro_not_6985(){
    sed -i '/# Corot opt/,/# Corot opt fin./d' "$MODPATH"/system.prop
}

hydro_6897(){
    cp -r "$MODPATH"/platform_config/a/duchamp/etc "$TMPDIR"
    cp -r "$MODPATH"/platform_config/a/duchamp/gnss "$MODPATH"/system/vendor/etc
    mkdir -p "$MODPATH"/system/product/etc
    #cp -r "$MODPATH"/platform_config/a/duchamp/device_features "$MODPATH"/system/product/etc
    sed -i 's/PERF_RES_CPUFREQ_MAX_CLUSTER/PERF_RES_CPUFREQ_MAX_HL_CLUSTER/g' "$MODPATH"/platform_config/a/power_config/etc/power_app_cfg.xml
    rm -f "$MODPATH"/platform_config/a/power_config/etc/powercontable.xml
    cp "$MODPATH"/platform_config/a/power_config/etc "$MODPATH"/system/vendor
    cp "$MODPATH"/platform_config/a/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
    hydro_disable_irishelper
}

hydro_6886(){
    cp -r "$MODPATH"/platform_config/a/zircon/etc "$TMPDIR"
    mkdir -p "$MODPATH"/system/product/etc
    cp -r "$MODPATH"/platform_config/a/zircon/gnss "$MODPATH"/system/vendor/etc
    #cp -r "$MODPATH"/platform_config/a/zircon/device_features "$MODPATH"/system/product/etc
    sed -i 's/PERF_RES_CPUFREQ_MAX_CLUSTER/PERF_RES_CPUFREQ_MAX_HL_CLUSTER/g' "$MODPATH"/platform_config/a/power_config/etc/power_app_cfg.xml
    sed -i '/AFFINITY/d' "$MODPATH"/platform_config/a/power_config/etc/power_app_cfg.xml
    rm -f "$MODPATH"/platform_config/a/power_config/etc/powercontable.xml
    cp "$MODPATH"/platform_config/a/power_config/etc "$MODPATH"/system/vendor
    cp "$MODPATH"/platform_config/a/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
    hydro_disable_irishelper
}

hydro_6895(){
    cp -r "$MODPATH"/platform_config/b/etc "$TMPDIR"
    cp "$MODPATH"/platform_config/b/power_config/etc "$MODPATH"/system/vendor
    sed -i "s/Xiaomi 23078RKD5C/$manufacturer $model/g" "$MODPATH"/joy_config/hardware_model_config.json
    cp "$MODPATH"/platform_config/b/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
    sed -i '/# GPU modify/,/# GPU modify fin./d' "$MODPATH"/functions.sh
    hydro_disable_irishelper
}

hydro_6983(){
    mkdir -p "$TMPDIR"/etc
    cp -r "$MODPATH"/platform_config/b/etc/dolby "$TMPDIR"/etc
    cp "$MODPATH"/platform_config/b/power_config/etc "$MODPATH"/system/vendor
    cp "$MODPATH"/platform_config/b/joy_config/booster_config_mtk.json "$MODPATH"/joy_config
    sed -i '/# GPU modify/,/# GPU modify fin./d' "$MODPATH"/functions.sh
    hydro_disable_irishelper
}

hydro_xaga(){
    mkdir -p "$MODPATH"/system/product/etc
    #cp -r "$MODPATH"/platform_config/b/xaga/device_features "$MODPATH"/system/product/etc
}

hydro_environment_detection(){
    case $lang in
    zh)
        hydro_print "--设备信息--"
        hydro_print "产品名称：$model"
        hydro_print "市场名称：$marketname"
        hydro_print "内核版本：$kernel_version"
        hydro_print "模块版本：$hydro_version ($hydro_versionCode)"
        ;;
    en)
        hydro_print "--Device info--"
        hydro_print "Product name: $model"
        hydro_print "Market name: $marketname"
        hydro_print "Kernel version: $kernel_version"
        hydro_print "Hydro version: $hydro_version ($hydro_versionCode)"
        ;;
    fr)
        hydro_print "--Info appareil--"
        hydro_print "Nom du produit: $model"
        hydro_print "Nom du marché: $marketname"
        hydro_print "Version du noyau: $kernel_version"
        hydro_print "Version du module: $hydro_version ($hydro_versionCode)"
        ;;
    esac
    if [ "$KSU" = "true" ]; then
        hydro_print "KernelSU: $KSU_VER_CODE"
    elif [ "$APATCH" = "true" ]; then
        hydro_print "APatch: $APATCH_VER_CODE"
    else
        hydro_print "Magisk: $MAGISK_VER_CODE"
        if [ "$MAGISK_VER_CODE" -lt 26000 ]; then
            case $lang in
            zh)
                hydro_print "请更新 Magisk 以使用本模块"
                abort
                ;;
            en)
                hydro_print "Outdated Magisk detected, please update!"
                abort
                ;;
            fr)
                hydro_print "Magisk obsolète détecté, veuillez mettre à jour !"
                abort
                ;;
            esac
        fi
    fi
    sed -i '/# Test sed for Magisk/,/# Test sed for Magisk fin./d' "$MODPATH"/system.prop
    if [ -d "$MODPATH"/platform_config -o "`sed -n '/# Test sed for Magisk/p' "$MODPATH"/system.prop`" -o "`sed -n '/# Test sed for Magisk fin./p' "$MODPATH"/system.prop`" ]; then
        print_line
        case "$lang" in
        zh)
            hydro_print "抱歉，你的 Magisk 不能正常工作，本模块将不会被安装！"
            ;;
        en)
            hydro_print "Sorry, your Magisk is not running properly, the module will not be installed! "
            ;;
        fr)
            hydro_print "Magisk ne fonctionne pas correctement et le module ne sera pas installé! "
            ;;
        esac
        print_line
        abort
    fi
    print_line
}

hydro_ksu_support(){
    if [ $KSU ]; then
        hydro_print "--Kernel SU"
    fi
}

check_module_prop(){
    local path=$1
    local prop_file=$path"/module.prop"
    if [ -f "$prop_file" ]; then
        grep -q "chenzy" "$prop_file" && return 0 || return 1
    else
        return 1
    fi
}

unins_module(){
    rm -f "$1/service.sh"
    rm -f "$1/post-fs-data.sh"
    rm -f "$1/system.prop"
    touch "$1/remove"
}

unins_select(){
    case $lang in
    zh)
        [ "$5" = "-1" ] && hydro_print "检测到 $3，请卸载此人的模块，否则将终止安装"
        [ "$5" = "1" ] && hydro_print "检测到冲突，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "5" ] && hydro_print "检测到已启用冲突的功能，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "0" ] && hydro_print "检测到可能的冲突，您愿意卸载来自 $3 的 $2 模块吗？"
        [ "$5" = "0" ] && [ "$conflict_prompt" = "" ] && hydro_print "若您存在语言功能障碍，请自行查阅\"可能\"一词的含义"
        conflict_prompt="1"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "检测到来自 $3 的 $2 模块存在与服务器通讯的行为"
            [ "$5" = "3" ] && hydro_print "检测到来自 $3 的 $2 模块存在使用 /dev/zero 的行为"
            [ "$5" = "4" ] && hydro_print "检测到来自 $3 的 $2 模块存在过长的 echo 命令，可能存在加密"
            hydro_print "请确保此模块的来源正当，否则存在损坏设备的风险"
            hydro_print "如果来源不明，请按音量键 + 以卸载"
        fi
        hydro_print "音量键 + : 是的"
        hydro_print "音量键 - : 不，我需要保留它"
        ;;
    en)
        [ "$5" = "-1" ] && hydro_print "$3 is detected, please uninstall his module, otherwise the installation will be forcibly cancelled"
        [ "$5" = "1" ] && hydro_print "Conflict detected, would you like to uninstall module $2 from $3?"
        [ "$5" = "5" ] && hydro_print "Conflicting enabled features detected, would you like to uninstall the $2 module from $3?"
        [ "$5" = "0" ] && hydro_print "Possible conflict detected, would you like to uninstall module $2 from $3?"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "Detected module $2 from $3 communicating with server"
            [ "$5" = "3" ] && hydro_print "Detected behavior of module $2 from $3 using /dev/zero"
            [ "$5" = "4" ] && hydro_print "Detected excessively long echo command in $2 module from $3, possible encryption"
            hydro_print "Please ensure that this module comes from a trustworthy source,"
            hydro_print "otherwise there is a risk of damaging the device"
            hydro_print "If the source is unknown, press volume key + to uninstall"
        fi
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No, that's unacceptable"
        ;;
    fr)
        [ "$5" = "-1" ] && hydro_print "3$ sont détectés, veuillez désinstaller son module, sinon l'installation sera annulée de force"
        [ "$5" = "1" ] && hydro_print "Conflit détecté, souhaitez-vous désinstaller le module $2 de $3 ?"
        [ "$5" = "5" ] && hydro_print "Fonctionnalités activées en conflit détectées. Souhaitez-vous désinstaller le module à $2 de celui à $3 ?"
        [ "$5" = "0" ] && hydro_print "Conflit possible détecté, souhaitez-vous désinstaller le module $2 de $3 ?"
        if [ $5 -ge 2 ]; then
            [ "$5" = "2" ] && hydro_print "Module détecté 2 $ sur 3 $ communiquant avec le serveur"
            [ "$5" = "3" ] && hydro_print "Comportement détecté du module $2 à partir de $3 en utilisant /dev/zero"
            [ "$5" = "4" ] && hydro_print "Commande d'écho trop longue détectée dans le module $2 à partir de $3, cryptage possible"
            hydro_print "Veuillez vous assurer que ce module provient d'une source fiable,"
            hydro_print "sinon il y a un risque d'endommager l'appareil"
            hydro_print "Si la source est inconnue, appuyez sur la touche de volume + pour désinstaller"
        fi
        hydro_print "Préféreriez-vous désinstaller le module $2 apporté par $3 ?"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non, c'est inacceptable"
        ;;
    esac
    local key_click_unins
    while [ "$key_click_unins" = "" ]; do
        key_click_unins=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_unins in
    KEY_VOLUMEUP)
        unins_module $1
        case $lang in
        zh)
            hydro_print "卸载完成"
            ;;
        en)
            hydro_print "Uninstallation completed, well done!"
            ;;
        fr)
            hydro_print "Désinstallation terminée, bravo !"
            ;;
        esac
        ;;
    *)
        if [ "$4" = "1" ]; then
            case $lang in
            zh)
                hydro_print "安装终止"
                ;;
            en)
                hydro_print "Installation terminated since not compatible with the module"
                ;;
            fr)
                hydro_print "Installation terminée car non compatible avec le module"
                ;;
            esac
            hydro_abort
        elif [ "$4" = "2" ]; then
            if [ "$6" = "1" ]; then
                key_click_1="KEY_VOLUMEDOWN"
            elif [ "$6" = "2" ]; then
                key_click_2="KEY_VOLUMEDOWN"
            fi
            case $lang in
            zh)
                hydro_print "未卸载，已关闭本模块中对应的功能"
                ;;
            en)
                hydro_print "Not uninstalled, the corresponding function in the module has been closed"
                ;;
            fr)
                hydro_print "Non désinstallé, la fonction correspondante dans ce module a été fermée"
                ;;
            esac
        else
            case $lang in
            zh)
                hydro_print "未卸载该模块，请确保你的行为是安全的，或自行承担可能的风险"
                ;;
            en)
                hydro_print "Retained the module"
                hydro_print "Please ensure that your behavior is safe or bear the possible risks at your own risk"
                ;;
            fr)
                hydro_print "Le module n'est pas désinstallé"
                hydro_print "Veuillez vous assurer que votre comportement est sûr ou supporter les risques possibles à vos propres risques"
                ;;
            esac
        fi
        ;;
    esac
    sleep 0.3
    print_line
}

unins_bypass(){
    local module_prop="$1/module.prop"
    local name=$(grep_prop name "$module_prop")
    local author=$(grep_prop author "$module_prop")
    case $lang in
    zh)
        hydro_print "检测到来自 $author 的 $name 模块存在放行标识"
        hydro_print "请确保此模块来源安全"
        ;;
    en)
        hydro_print "Bypass flag detected for module $name from $author"
        hydro_print "Please ensure that the source of this module is safe"
        ;;
    fr)
        hydro_print "Indicateur de contournement détecté pour le module $name à partir de $author"
        hydro_print "Veuillez vous assurer que la source de ce module est sûre"
        ;;
    esac
    print_line
}

uninstall_module(){
    local module_prop="$1/module.prop"
    local name=$(grep_prop name "$module_prop")
    local author=$(grep_prop author "$module_prop")
    unins_select "$1" "$name" "$author" "$2" "$3" "$4"
}

hydro_fakemodel_abort(){
    case $lang in
    zh)
        hydro_print "检测到机型伪装模块，请将其卸载，重启后重新安装本模块"
        ;;
    en)
        hydro_print "Device model camouflage module detected"
        hydro_print "Please uninstall it and reinstall the module after rebooting"
        ;;
    fr)
        hydro_print "Module de camouflage du modèle d'appareil détecté"
        hydro_print "Veuillez le désinstaller et réinstaller le module après le redémarrage"
        ;;
    esac
    hydro_abort
}

heil_nakixii(){
    if [ ! -d "/data/adb/modules/asoul_affinity_opt" -a ! -d "/data/adb/modules_update/asoul_affinity_opt" ]; then
        case $lang in
        zh)
            hydro_print "未安装 A-SOUL Games Optimization 模块，即将自动安装"
            ;;
        en)
            hydro_print "A-SOUL Games Optimization module is not installed"
            hydro_print "It will be installed automatically"
            ;;
        fr)
            hydro_print "Le module A-SOUL Games Optimization n'est pas installé"
            hydro_print "ItIl sera installé automatiquement"
            ;;
        esac
        print_line
        magisk --install-module "$MODPATH/assets/Asoul_Opt.zip"
        print_line
    elif [ -f "/data/adb/modules/asoul_affinity_opt/module.prop" ]; then
        asopt_versionCode=$(grep_prop versionCode /data/adb/modules/asoul_affinity_opt/module.prop)
        if [ $asopt_versionCode -lt 268 ]; then
            case $lang in
            zh)
                hydro_print "正在更新 A-SOUL Games Optimization 模块"
                ;;
            en)
                hydro_print "Updating A-SOUL Games Optimization module"
                ;;
            fr)
                hydro_print "Mise à jour du module A-SOUL Games Optimization"
                ;;
            esac
            print_line
         fi
    fi
    rm -f "$MODPATH/assets/Asoul_Opt.zip"
}

hydro_cure(){
    case $lang in
    zh)
        hydro_print "正在进行环境安全性检测，请耐心等待……"
        ;;
    en)
        hydro_print "Environmental safety testing is in progress, please wait patiently..."
        ;;
    fr)
        hydro_print "Les tests de sécurité environnementale sont en cours, veuillez patienter..."
        ;;
    esac
    print_line
    if pm list packages | grep -q "xyz.chenzyadb.cu_toolbox"; then
        case $lang in
        zh)
            hydro_print "检测到来自 @chenzyadb 的不兼容调度，安装终止"
            ;;
        en)
            hydro_print "Malicious scheduler by @chenzyadb detected, aborting"
            ;;
        fr)
            hydro_print "Planificateur malveillant par @chenzyadb détecté, abandon"
            ;;
        esac
        hydro_abort
    fi
    local dir
    local subdir
    for dir in /data/adb/modules /data/adb/modules_update; do
        for subdir in $(find "$dir" -maxdepth 1 -type d); do
            local module_prop="$subdir/module.prop"
            local system_prop="$subdir/system.prop"
            local service="$subdir/service.sh"
            local bypass="$subdir/ab_certified"
            local author=$(grep_prop author "$module_prop")
            local folder=$(basename "$subdir")
            if [ -f "$module_prop" -a ! -e "$bypass" -a ! -e "$subdir"/remove -a "$folder" != "ab_optimizer" -a "$folder" != "extreme_gt" -a "$author" != "嘟嘟ski" -a "$author" != "nakixii" ]; then
                if grep -q -i -e 'int萌新很新' -e '水竹闲士' -e 'SutoLiu' "$module_prop"; then
                    uninstall_module "$subdir" "1" "-1"
                elif grep -q -e 'ro.product.name' -e 'ro.product.brand' "$system_prop"; then
                    uninstall_module "$subdir" "1" "1"
                    hydro_fakemodel_abort
                fi
                if grep -q -i -e '触控' -e '超频响应' -e 'MEMC' "$module_prop"; then
                    uninstall_module $subdir "0" "0"
                elif find "$subdir"/ | grep -q -i -e 'iris' -e 'pixelworks'; then
                    uninstall_module $subdir "0" "0"
                fi
                if [ "$key_click_1" = "KEY_VOLUMEUP" ]; then
                    if grep -q -i -e 'olby' -e '音频' -e '哈曼' "$module_prop"; then
                        uninstall_module $subdir "2" "5" "2"
                    elif find "$subdir"/ | grep -q -i -e 'audio' -e 'dolby'; then
                        uninstall_module $subdir "2" "5" "2"
                    fi
                fi
                if [ "$key_click_9" = "KEY_VOLUMEUP" ]; then
                    if grep -q -i -e '震动' -e '振动' -e 'bration' -e 'brator' -e 'haptic' "$module_prop"; then
                        uninstall_module $subdir "2" "5" "1"
                    fi
                fi
                if grep -q 'curl' "$service"; then
                    uninstall_module $subdir "0" "2"
                elif grep -q '/dev/zero' "$service"; then
                    uninstall_module $subdir "0" "3"
                fi
                while IFS= read -r line; do
                    if echo "$line" | grep -q "^echo" && [ "${#line}" -gt 80 ]; then
                        uninstall_module $subdir "0" "4"
                        break
                    fi
                done < "$service"
            elif [ -e "$bypass" -o "$author" = "嘟嘟ski" -o "$author" = "nakixii" ]; then
                unins_bypass $subdir
            fi
        done
    done
    #heil_nakixii
    case $lang in
    zh)
        hydro_print "环境检测完毕"
        ;;
    en)
        hydro_print "Environmental testing completed"
        ;;
    fr)
        hydro_print "Tests environnementaux terminés"
        ;;
    esac
    print_line
}

hydro_cure_select(){
    case $lang in
    zh)
        hydro_print "请选择是否进行安装环境检测"
        hydro_print "本流程会自动检测潜在的恶意模块以及冲突"
        hydro_print "如果存在冲突，本模块会自动避让相关的功能；"
        hydro_print "若无法避让，你可以选择卸载冲突模块或退出安装"
        hydro_print "注意！若跳过此流程，可能会导致部分功能冲突，甚至阻止设备正常工作"
        hydro_print "同时，你的任何反馈均不会被视作有效"
        hydro_print "音量键 + : 进行环境检测"
        hydro_print "音量键 - : 跳过环境检测"
        ;;
    en)
        hydro_print "Choose whether to have an environment detection"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : Skip"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez avoir une détection d'environnement"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_cure" = "" ]; do
        key_click_cure=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_cure in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        print_line
        hydro_cure
        ;;
    *)
        hydro_print "-- ✖"
        print_line
        ;;
    esac
}

hydro_soc_detect(){
    [ "$soc" = "mt6989" ] && hydro_6989
    if [ "$soc" = "mt6985" ]; then
        hydro_6985
    else
        hydro_not_6985
    fi
    if [ "$soc" = "mt6897" ]; then
        hydro_6897
    fi
    if [ "$soc" = "mt6886" ]; then
        hydro_6886
    fi
    if [ "$soc" = "mt6895" -o "$soc" = "mt6896" ]; then
        hydro_6895
        if [ "$device" = "xaga" ]; then
            hydro_xaga
        fi
    fi
    if [ "$soc" = "mt6983" ]; then
        hydro_6983
    fi
    rm -rf "$MODPATH"/platform_config
}

hydro_injection(){
    case "$lang" in
    zh)
        if [ -f "/data/adb/modules_update/pandora_kernel/service.sh" ]; then
            hydro_pandora_update
            hydro_print "--检测到 Pandora 内核附加模块更新，注入中"
        fi
        if [ -f "/data/adb/modules_update/angelbeats_kernel/service.sh" ]; then
            hydro_ab_update
            hydro_print "--检测到 AB 内核附加模块更新，注入中"
        fi
        if [ -f "/data/adb/modules_update/yuni_kernel/service.sh" ]; then
            hydro_yuni_update
            hydro_print "--检测到 Yuni 内核附加模块更新，注入中"
        fi
        if [ "$hydro_update_flag" != "1" ]; then
            if [ "$h_yuni_kernel" = "3" ]; then
                hydro_pandora_kernel
                hydro_print "--检测到 Pandora 内核，注入中"
            fi
            if [ "$h_yuni_kernel" = "2" ]; then
                hydro_ab_kernel
                hydro_print "--检测到 AB 内核，注入中"
            fi
            if [ "$h_yuni_kernel" = "1" ]; then
                hydro_yuni_kernel
                hydro_print "--检测到 Yuni 内核，注入中"
            fi
            if [ "$h_yuni_kernel" = "0" ]; then
                hydro_official_kernel
                hydro_print "--检测到官方内核，注入中"
                hydro_print "--推荐使用 Pandora 内核，QQ 频道号 36ul8o5au2"
            fi
        fi
        print_line
        ;;
    en)
        if [ -f "/data/adb/modules_update/pandora_kernel/service.sh" ]; then
            hydro_pandora_update
            hydro_print "--Pandora Kernel update detected, injecting"
        fi
        if [ -f "/data/adb/modules_update/angelbeats_kernel/service.sh" ]; then
            hydro_ab_update
            hydro_print "--AngelBeats Kernel update detected, injecting"
        fi
        if [ -f "/data/adb/modules_update/yuni_kernel/service.sh" ]; then
            hydro_yuni_update
            hydro_print "--Yuni Kernel update detected, injecting"
        fi
        if [ "$hydro_update_flag" != "1" ]; then
            if [ "$h_yuni_kernel" = "3" ]; then
                hydro_pandora_kernel
                hydro_print "--Pandora Kernel detected, injecting"
            fi
            if [ "$h_yuni_kernel" = "2" ]; then
                hydro_ab_kernel
                hydro_print "--AngelBeats Kernel detected, injecting"
            fi
            if [ "$h_yuni_kernel" = "1" ]; then
                hydro_yuni_kernel
                hydro_print "--Yuni Kernel detected, injecting"
            fi
            if [ "$h_yuni_kernel" = "0" ]; then
                hydro_official_kernel
                hydro_print "--Official Kernel detected, injecting"
            fi
        fi
        print_line
        ;;
    fr)
        if [ -f "/data/adb/modules_update/pandora_kernel/service.sh" ]; then
            hydro_pandora_update
            hydro_print "--Mise à jour du kernel détectée, injection en cours"
        fi
        if [ -f "/data/adb/modules_update/angelbeats_kernel/service.sh" ]; then
            hydro_ab_update
            hydro_print "--Mise à jour du kernel détectée, injection en cours"
        fi
        if [ -f "/data/adb/modules_update/yuni_kernel/service.sh" ]; then
            hydro_yuni_update
            hydro_print "--Mise à jour du kernel détectée, injection en cours"
        fi
        if [ "$hydro_update_flag" != "1" ]; then
            if [ "$h_yuni_kernel" = "3" ]; then
                hydro_ab_kernel
                hydro_print "--Pandora Kernel détecté, injection en cours"
            fi
            if [ "$h_yuni_kernel" = "2" ]; then
                hydro_ab_kernel
                hydro_print "--AngelBeats Kernel détecté, injection en cours"
            fi
            if [ "$h_yuni_kernel" = "1" ]; then
                hydro_yuni_kernel
                hydro_print "--Yuni Kernel détecté, injection en cours"
            fi
            if [ "$h_yuni_kernel" = "0" ]; then
                hydro_official_kernel
                hydro_print "--Kernel officiel détecté, injection en cours"
            fi
        fi
        print_line
        ;;
    esac
}

hydro_settings_backup(){
    touch $settings
    {
       echo "1:$key_click_1"
       echo "2:$key_click_2"
       echo "3:$key_click_3"
       echo "4:$key_click_4"
       echo "5:$key_click_5"
       echo "6:$key_click_6"
       echo "7:$key_click_7"
       echo "8:$key_click_8"
       echo "9:$key_click_9"
       echo "10:$key_click_10"
       echo "en:$key_click_en"
       echo "fr:$key_click_fr"
       echo "}"
    } >> $settings
}

hydro_read_settings(){
    while read -r lineP; do
        case "$lineP" in
        1:*)
           param=${lineP#1:}
           key_click_1=$param
           ;;
        2:*)
           param=${lineP#2:}
           key_click_2=$param
           ;;
        3:*)
           param=${lineP#3:}
           key_click_3=$param
           ;;
        4:*)
           param=${lineP#4:}
           key_click_4=$param
           ;;
        5:*)
           param=${lineP#5:}
           key_click_5=$param
           ;;
        6:*)
           param=${lineP#6:}
           key_click_6=$param
           ;;
        7:*)
           param=${lineP#7:}
           key_click_7=$param
           ;;
        8:*)
           param=${lineP#8:}
           key_click_8=$param
           ;;
        9:*)
           param=${lineP#9:}
           key_click_9=$param
           ;;
        10:*)
           param=${lineP#10:}
           key_click_10=$param
           ;;
        en:*)
           param=${lineP#en:}
           key_click_en=$param
           ;;
        fr:*)
           param=${lineP#fr:}
           key_click_fr=$param
           ;;
        "}")
           break
           ;;
        esac
    done < $settings_old
}

hydro_device_support(){
    if [ "$manufacturer" != "Xiaomi" ] || [ "$soc" != "mt6989" -a "$soc" != "mt6985" -a "$soc" != "mt6897" -a "$soc" != "mt6886" "$soc" != "mt6895" -a "$soc" != "mt6983" -a "$soc" != "mt6896" ]; then
        hydro_print "未受支持的设备"
        hydro_abort
    fi
}

hydro_hyper_os(){
    hydro_disable_vibration
}

hydro_iris_cfg_update(){
    if [ -f /data/adb/modules/ab_optimizer/iris/iriscfgcustomize.conf ]; then
        cp /data/adb/modules/ab_optimizer/iris/iriscfgcustomize.conf "$MODPATH"/iris/iriscfgcustomize.conf
    fi
}

hydro_disable_vibration(){
    rm -rf "$MODPATH"/system/vendor/firmware
    sed -i '/# Vibration/,/# Vibration fin./d' "$MODPATH"/system.prop
}

hydro_vibration_install(){
    case $lang in
    zh)
        hydro_print "是否启用来自 mly 的振动修改？"
        hydro_print "音量键 + : 启用振动修改"
        hydro_print "音量键 - : 禁用振动修改"
        ;;
    en)
        hydro_print "Choose whether to enable vibrance modification"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non l'amélioration des vibrations"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_1" = "" ]; do
        key_click_1=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_1 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_vibration
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_irishelper(){
    if [ "$soc" = "mt6985" ]; then
        rm -f "$MODPATH"/iris/iriscfgcustomize.conf
        rm -f "$MODPATH"/iris/iris_helper.sh
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
    else
        rm -rf "$MODPATH"/iris
        sed -i '/# Iris mod/,/# Iris mod fin./d' "$MODPATH"/post-fs-data.sh
    fi
    sed -i '/# Iris Helper by AB/,/# Iris Helper fin./d' "$MODPATH"/service.sh
}

hydro_iris_install(){
    case $lang in
    zh)
        hydro_print "是否启用 Iris Helper?"
        hydro_print "该功能能够自定义包括 MEMC、HDR 在内的一些显示参数"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable Iris Helper"
        hydro_print "This function can customize some display parameters including MEMC and HDR"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer Iris Helper"
        hydro_print "Cette fonction permet de personnaliser certains paramètres d'affichage dont MEMC et HDR"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_7" = "" ]; do
        key_click_7=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_7 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        case $lang in
        zh)
            hydro_print "--注意！你必须将每一个你需要启用 X7 功能的 App 列入配置文件！"
            hydro_print "--未在配置文件内的 App 均会被禁用 X7 相关功能"
            hydro_print "--配置文件和使用说明在 /data/adb/modules/ab_optimizer/iris 内"
            ;;
        en)
            hydro_print "--Attention! You have to list every single app which needs MEMC in configuration file!"
            hydro_print "--Apps that are not included in the configuration file will have X7 related functions disabled"
            hydro_print "--The configuration file is in /data/adb/modules/ab_optimizer/iris"
            ;;
        fr)
            hydro_print "--Attention! Vous devez lister chaque application qui a besoin de MEMC dans le fichier de configuration !"
            hydro_print "--Les applications qui ne sont pas incluses dans le fichier de configuration auront les fonctions liées à X7 désactivées"
            hydro_print "--Le fichier de configuration est dans /data/adb/modules/ab_optimizer/iris"
            ;;
        esac
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_irishelper
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_disable_pxlw_enhance(){
    rm -f "$MODPATH/odm/etc/iris_configs.xml"
}

hydro_pxlw_enhance_install(){
    case $lang in
    zh)
        hydro_print "是否启用 Pixelworks X7 优化？"
        hydro_print "这个功能优化了部分游戏的超帧超分效果"
        hydro_print "并为 Iris Helper 提供更多的可用预设"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        ;;
    en)
        hydro_print "Choose whether to enable Pixelworks X7 optimization"
        hydro_print "This function optimizes MEMC and super-resolution effects of some games"
        hydro_print "Provide more available presets for Iris Helper in addition"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation Pixelworks X7"
        hydro_print "Cette fonction optimise les effets MEMC et super-résolution de certains jeux"
        hydro_print "Fournir davantage de préréglages disponibles pour Iris Helper"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        ;;
    esac
    while [ "$key_click_4" = "" ]; do
        key_click_4=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_4 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_pxlw_enhance
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_enable_soundfx(){
    cp -r "$TMPDIR"/etc "$MODPATH"/system/vendor
}

hydro_enable_soundfx_alt(){
    cp -r "$TMPDIR"/alternative/etc "$MODPATH"/system/vendor
}

hydro_disable_soundfx(){
    rm -rf "$MODPATH"/system/priv-app
    sed -i '/# Audio/,/# Audio fin./d' "$MODPATH"/system.prop
}

hydro_soundfx_install(){
    case $lang in
    zh)
        hydro_print "是否启用音频优化？"
        hydro_print "可绕过SRC，提供更低的延时和更高保真的音频表现"
        hydro_print "可能会导致一些未知问题，请自行尝试"
        hydro_print "音量键 + : 启用音频优化"
        hydro_print "音量键 - : 不启用音频优化"
        ;;
    en)
        hydro_print "Choose whether to enable sound effects modification"
        hydro_print "May perform abnormally on certain scenes"
        hydro_print "Volume + : Enable sound optimization"
        hydro_print "Volume - : Disable sound optimization"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer la modification des effets sonores"
        hydro_print "Peut fonctionner anormalement sur certaines scènes"
        hydro_print "Volume + : Activer l'optimisation du son"
        hydro_print "Volume + : Désactiver l'optimisation du son"
        ;;
    esac
    while [ "$key_click_2" = "" ]; do
        key_click_2=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_2 in
    KEY_VOLUMEUP)
        [ "$soc" != "mt6985" ] && hydro_enable_soundfx
        [ "$soc" = "mt6985" ] && hydro_dax_install
        case $lang in
        zh)
            hydro_print "--已安装音效修改"
            hydro_print "--你需要手动安装模块压缩包内的 MusicFX.apk 以确保音效正常工作！"
            ;;
        en)
            hydro_print "--Sound effects enabled"
            hydro_print "--You need to manually install MusicFX.apk in the module's zip package to ensure that the sound effect works properly!"
            ;;
        fr)
            hydro_print "--Effets sonores activés"
            hydro_print "--Vous devez installer manuellement MusicFX.apk dans le package zip du module pour vous assurer que l'effet sonore fonctionne correctement! "
            ;;
        esac
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_soundfx
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_dax_install(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "现在，请选择你所需要的音效"
        hydro_print "音量键 + : 启用来自 素菜 调整的音效修改，包括耳机EQ等，听感更舒适"
        hydro_print "音量键 - : 启用来自 AB 调整的音效修改，仅包含扬声器EQ，听感更原味"
        ;;
    en)
        hydro_print "Now, choose the EQ preset you prefer"
        hydro_print "Volume + : Enable dax file from 素菜，including EQ for earphones"
        hydro_print "Volume - : Enable dax file from AB ，only include EQ for speakers"
        ;;
    fr)
        hydro_print "Maintenant, choisissez votre préréglage EQ préféré"
        hydro_print "Volume +: active les fichiers Dax depuis Dax 素菜, casque EQ inclus"
        hydro_print "Volume -: active les fichiers Dax depuis AB, inclut uniquement l'EQ du Haut - parleur"
        ;;
    esac
    while [ "$key_click_8" = "" ]; do
        key_click_8=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_8 in
    KEY_VOLUMEUP)
        case $lang in
        zh)
            hydro_print "--已安装 素菜 的音效修改"
            ;;
        en)
            hydro_print "--EQ from 素菜 installed"
            ;;
        fr)
            hydro_print "--Fichier EQ de 素菜 installé"
            ;;
        esac
        hydro_enable_soundfx_alt
        ;;
    *)
        case $lang in
        zh)
            hydro_print "--已安装 AB 的音效修改"
            ;;
        en)
            hydro_print "--EQ from AB installed"
            ;;
        fr)
            hydro_print "--Fichier EQ de AB installé"
            ;;
        esac
        hydro_enable_soundfx
        ;;
    esac
}

hydro_disable_sfopt(){
    sed -i '/# Renderer optimize/,/# Renderer optimize fin./d' "$MODPATH"/system.prop
}

hydro_sfopt_install(){
    case $lang in
    zh)
        hydro_print "是否启用渲染优化？"
        hydro_print "本修改包括 surfaceflinger 调整"
        hydro_print "提供更高效的图形处理、更低的操作时延和更平滑的动画体验"
        hydro_print "在过于旧的驱动和软件环境下可能会产生错误"
        hydro_print "音量键 + : 开启渲染优化"
        hydro_print "音量键 - : 关闭渲染优化"
        ;;
    en)
        hydro_print "Choose whether to enable renderer optimization"
        hydro_print "Including urfaceflinger optimization"
        hydro_print "Provides more efficient graphics processing,"
        hydro_print "lower operation latency and smoother animation experience"
        hydro_print "Errors may occur in older driver and software environments"
        hydro_print "Volume + : Enable renderer optimization"
        hydro_print "Volume - : Disable renderer optimization"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer l'optimisation du moteur de rendu"
        hydro_print "Y compris l'optimisation d'urfaceflinger"
        hydro_print "Fournit un traitement graphique plus efficace,"
        hydro_print "une latence de fonctionnement plus faible et une expérience d'animation plus fluide"
        hydro_print "Des erreurs peuvent survenir dans les anciens environnements de pilotes et de logiciels"
        hydro_print "Volume + : Activer l'optimisation du moteur de rendu"
        hydro_print "Volume - : Désactiver l'optimisation du moteur de rendu"
        ;;
    esac
    while [ "$key_click_0" = "" ]; do
        key_click_0=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_0 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_sfopt
        ;;
    esac
    sleep 0.3
    print_line
}

hydro_enable_vulkan(){
    sed -i "s/Xiaomi 23078RKD5C/$manufacturer $model/g" "$MODPATH"/joy_config/hardware_model_config.json
}

hydro_disable_vulkan(){
    sed -i 's/"vulkanFlag": 1/"vulkanFlag": 0/' "$MODPATH"/assets/hardware_model_config.json
}

hydro_ysvk_install(){
    case $lang in
    zh)
        hydro_print "是否强行启用原神的 Vulkan 支持？"
        hydro_print "这会显著降低原神的性能需求"
        hydro_print "提供更长的续航、更低的温度和更平滑的画面表现"
        sleep 0.2
        hydro_print "但会在少数场景显示异常，并需要重新预载着色器"
        hydro_print "亦会导致游戏助手修改分辨率的手段失效"
        hydro_print "音量键 + : 使用 Vulkan"
        hydro_print "音量键 - : 使用 OpenGL(默认)"
        ;;
    en)
        hydro_print "Choose whether to forcibly enable Genshin Impact's Vulkan support"
        hydro_print "This will significantly improve the performance"
        hydro_print "Provides longer battery life, lower temperature and smoother frame rate"
        sleep 0.2
        hydro_print "Will display exceptions in a few scenes and the shader needs to be reloaded"
        hydro_print "Volume + : Use Vulkan"
        hydro_print "Volume - : Use OpenGL"
        ;;
    fr)
        hydro_print "Choisissez d'activer ou non de force le support Vulkan de Genshin Impact"
        hydro_print "Cela améliorera considérablement les performances"
        hydro_print "Offre une durée de vie de la batterie plus longue,"
        sleep 0.2
        hydro_print "une température plus basse et une fréquence d'images plus fluide"
        hydro_print "Affichera les exceptions dans quelques scènes et le shader devra être rechargé"
        hydro_print "Volume + : Utiliser Vulkan"
        hydro_print "Volume - : Utiliser OpenGL"
        ;;
    esac
    while [ "$key_click_5" = "" ]; do
        key_click_5=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_5 in
    KEY_VOLUMEUP)
        hydro_print "-- ✔"
        case $lang in
        zh)
            hydro_print "将 /data/adb/modules/ab_optimizer/assets/ 内的文件"
            hydro_print "手动复制进对应目录以确保其生效"
            ;;
        en)
            hydro_print "Put the files in /data/adb/modules/ab_optimizer/assets/"
            hydro_print "Manually into the corresponding game directory to ensure it takes effect"
            ;;
        fr)
            hydro_print "Placez les fichiers dans /data/adb/modules/ab_optimizer/assets/"
            hydro_print "Manuellement dans le répertoire du jeu correspondant pour garantir qu'il prend effet"
            ;;
        esac
        hydro_enable_vulkan
        ;;
    *)
        hydro_print "-- ✖"
        hydro_disable_vulkan
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_enable_perfopt(){
    return 0
}

hydro_disable_perfopt(){
    sed -i '/# Performance adjustment/,/# Performance adjustment fin./d' "$MODPATH/assets/functions.sh"
}

hydro_perfopt_install(){
    case $lang in
    zh)
        hydro_print "Hydro Power 3.0 全域智慧加速引擎"
        hydro_print "内核级实现CPU、GPU、内存等资源分配"
        hydro_print "利用场景感知、卡顿感知、触摸感知最优化手机效能"
        hydro_print "启用全局均衡模式还是性能模式?"
        hydro_print "本选项对性能的影响不大, 建议选择均衡模式"
        hydro_print "性能模式会提供更高的频率和核心温度上限"
        hydro_print "本功能会被其他用户态调度覆盖，不用担心冲突问题"
        hydro_print "音量键 + : 均衡模式"
        hydro_print "音量键 - : 性能模式"
        ;;
    en)
        hydro_print "Enable balanced mode or performance mode?"
        hydro_print "This option has little impact on battery life and performance. It is recommended to choose balanced mode"
        hydro_print "Volume + : Balanced mode"
        hydro_print "Volume - : Performance mode"
        ;;
    fr)
        hydro_print "Activer le mode d'équilibre d'énergie ou le mode performance ?"
        hydro_print "Cette option a peu d'impact sur la durée de vie et les performances de la batterie. Il est recommandé de choisir le mode d'équilibre"
        hydro_print "Volume + : Mode équilibré"
        hydro_print "Volume - : Mode performance"
        ;;
    esac
    while [ "$key_click_6" = "" ]; do
        key_click_6=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_6 in
    KEY_VOLUMEUP)
        case $lang in
        zh)
            hydro_print "--已启用均衡模式"
            ;;
        en)
            hydro_print "--Balanced mode activated"
            ;;
        fr)
            hydro_print "--Mode équilibré activé"
            ;;
        esac
        hydro_power_balanced
        ;;
    *)
        case $lang in
        zh)
            hydro_print "--已启用性能模式"
            ;;
        en)
            hydro_print "--Performance mode activated"
            ;;
        fr)
            hydro_print "--Mode performance désactivé"
            ;;
        esac
        hydro_power_performance
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_refresh_aggressive(){
    if [ "$device" = "rubens" -o "$device" = "matisse" -o "$device" = "xaga" -o "$device" = "pearl" ]; then
        sed -i '/ro.vendor.disable_idle_fps.threshold/d' "$MODPATH"/system.prop
    fi
}

hydro_refresh_default(){
    sed -i '/# Idle control/,/# Idle control fin./d' "$MODPATH"/system.prop
    sed -i '/# Advanced sf drr/,/# Advanced sf drr fin./d' "$MODPATH"/system.prop
}

hydro_refresh_disable(){
    sed -i -r 's/debug.sf.set_idle_timer_ms=400/debug.sf.set_idle_timer_ms=0/g' "$MODPATH"/system.prop
    sed -i '/ro.vendor.disable_idle_fps.threshold/d' "$MODPATH"/system.prop
    sed -i '/# Advanced sf drr/,/# Advanced sf drr fin./d' "$MODPATH"/system.prop
}

hydro_vrr_install(){
    case $lang in
    zh)
        hydro_print "是否启用更激进的/保守的闲置刷新率策略？"
        hydro_print "这不一定能改变多少功耗，但会对频闪表现产生影响"
        hydro_print "启用修改后，需要清除电量和性能的数据以使小米刷新率管理正常工作"
        hydro_print "音量键 + : 开启修改后的闲置刷新率策略"
        hydro_print "音量键 - : 采用官方默认策略"
        ;;
    en)
        hydro_print "Choose whether to enable a more aggressive/conservative idle refresh rate policy"
        hydro_print "This won't necessarily change the power consumption, but it will have an impact on the flicker performance"
        hydro_print "After enabling the modification, the data on power and performance need to be cleared for Xiaomi refresh rate management to work properly"
        hydro_print "Volume +: Enable the modified idle refresh rate policy"
        hydro_print "Volume -: Use the official default strategy"
        ;;
    fr)
        hydro_print "Choisissez si vous souhaitez activer une politique de taux de rafraîchissement d'inactivité plus agressive/conservatrice"
        hydro_print "Cela ne modifiera pas nécessairement la consommation électrique, mais cela aura un impact sur les performances de scintillement."
        hydro_print "Après avoir activé la modification, les données sur la puissance et les performances doivent être effacées pour que la gestion du taux de rafraîchissement de Xiaomi fonctionne correctement"
        hydro_print "Volume + : Activer la politique de taux de rafraîchissement d'inactivité modifiée"
        hydro_print "Volume - : Utiliser la stratégie officielle par défaut"
        ;;
    esac
    while [ "$key_click_9" = "" ]; do
        key_click_9=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_9 in
    KEY_VOLUMEUP)
        hydro_vrr_install_opt
        ;;
    *)
        case $lang in
        zh)
            hydro_print "--已关闭闲置刷新率修改"
            ;;
        en)
            hydro_print "--Idle refresh rate modification disabled"
            ;;
        fr)
            hydro_print "--Modification du taux de rafraîchissement au ralenti désactivée"
            ;;
        esac
        hydro_refresh_default
        ;;
    esac
    sleep 0.5
    print_line
}

hydro_vrr_install_opt(){
    sleep 0.5
    print_line
    case $lang in
    zh)
        hydro_print "请选择是采用激进的闲置刷新率策略，还是关闭闲置刷新率策略"
        hydro_print "激进的策略有助于节省功耗，关闭策略有助于降低频闪风险"
        hydro_print "音量键 + : 开启激进的的闲置刷新率策略"
        hydro_print "音量键 - : 禁用闲置刷新率策略"
        ;;
    en)
        hydro_print "Please choose whether to use an aggressive idle refresh rate policy or turn off the idle refresh rate policy"
        hydro_print "Aggressive strategy helps save power consumption, shutdown strategy helps reduce flicker risk"
        hydro_print "Volume + : Enable aggressive idle refresh rate strategy"
        hydro_print "Volume - : Disable idle refresh rate policy"
        ;;
    fr)
        hydro_print "--Veuillez choisir si vous souhaitez utiliser une politique de taux de rafraîchissement inactif agressive ou désactiver la politique de taux de rafraîchissement inactif"
        hydro_print "--Une stratégie agressive permet d'économiser la consommation d'énergie, la stratégie d'arrêt contribue à réduire le risque de scintillement"
        hydro_print "Volume + : Activez une stratégie agressive de taux de rafraîchissement au ralenti"
        hydro_print "Volume - : Désactiver la politique de taux de rafraîchissement inactif"
        ;;
    esac
    while [ "$key_click_10" = "" ]; do
        key_click_10=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
        sleep 0.2
    done
    case $key_click_10 in
    KEY_VOLUMEUP)
        case $lang in
        zh)
            hydro_print "--已启用激进的闲置刷新率策略"
            ;;
        en)
            hydro_print "--Aggressive idle refresh rate strategy enabled"
            ;;
        fr)
            hydro_print "--Stratégie de taux de rafraîchissement agressive au ralenti activée"
            ;;
        esac
        hydro_refresh_aggressive
        ;;
    *)
        case $lang in
        zh)
            hydro_print "--已禁用闲置刷新率策略"
            ;;
        en)
            hydro_print "--Idle refresh rate policy disabled"
            ;;
        fr)
            hydro_print "--Politique de taux de rafraîchissement inactif désactivée"
            ;;
        esac
        hydro_refresh_disable
        ;;
    esac
    sleep 0.5
}

hydro_install_completed(){
    case $lang in
    zh)
        hydro_print "安装完成"
        hydro_print "请确保你已经阅读了以上全部的安装提示"
        hydro_print "在模块目录 /data/adb/modules/ab_optimizer 内有更详细的帮助文档"
        hydro_print "如果你遇到了问题，请阅读它"
        hydro_print "加入QQ群聊 902556931 以反馈、交流和获取测试版更新"
        sleep 0.2
        hydro_print "现在，尽情欢呼吧！"
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    en)
        hydro_print "Installation completed"
        hydro_print "Please ensure that you have been aware of the above precautions"
        hydro_print "There is more detailed help documentation in the module directory /data/adb/modules/ab_optimizer"
        hydro_print "If you have a problem, read it"
        hydro_print "Feedback and bug report via 981916119@qq.com"
        sleep 0.2
        hydro_print "Now, you will rejoice this! "
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    fr)
        hydro_print "installation terminée"
        hydro_print "Veuillez vous assurer que vous avez pris connaissance des précautions ci-dessus"
        hydro_print "Il existe une documentation d'aide plus détaillée dans le répertoire du module /data/adb/modules/ab_optimizer"
        hydro_print "Si vous avez un problème, lisez-le"
        hydro_print "Commentaires et rapport de bug via 981916119@qq.com"
        sleep 0.2
        hydro_print "Maintenant, vous vous en réjouirez !"
        hydro_print ""
        hydro_print ""
        hydro_print ""
        ;;
    esac
}

hydro_apply_settings(){
    hydro_print "--Installing"
    case $key_click_0 in
    KEY_VOLUMEUP)
        hydro_print "--Renderer optimization enabled"
        ;;
    *)
        hydro_print "--Renderer optimization disabled"
        hydro_disable_sfopt
        ;;
    esac
    if [ "$android_version" = "14" ]; then
        hydro_hyper_os
    else
        case $key_click_1 in
        KEY_VOLUMEUP)
            hydro_print "--Vibrance modification installed"
            ;;
        *)
            hydro_print "--Vibrance modification disabled"
            hydro_disable_vibration
            ;;
        esac  
    fi
    case $key_click_2 in
    KEY_VOLUMEUP)
        if [ "$soc" = "mt6985" ]; then
            case $key_click_8 in
            KEY_VOLUMEUP)
                hydro_print "--EQ from 素菜 installed"
                hydro_enable_soundfx_alt
                ;;
            *)
                hydro_print "--EQ from AB installed"
                hydro_enable_soundfx
                ;;
            esac
            hydro_print "--Sound optimization activated"
        else
            hydro_print "--Sound optimization activated"
            hydro_enable_soundfx
        fi
        ;;
    *)
        hydro_print "--Sound optimization disabled"
        hydro_disable_soundfx
        ;;
    esac
    case $key_click_5 in
    KEY_VOLUMEUP)
        hydro_print "--Vulkan enabled for YuanShen"
        hydro_enable_vulkan
        ;;
    *)
        hydro_print "--Vulkan disabled for YuanShen"
        hydro_disable_vulkan
        ;;
    esac
    case $key_click_6 in
    KEY_VOLUMEUP)
        hydro_print "--Balanced mode activated"
        hydro_power_balanced
        ;;
    *)
        hydro_print "--Performance mode activated"
        hydro_power_performance
        ;;
    esac
    case $key_click_7 in
    KEY_VOLUMEUP)
        hydro_print "--Iris helper activated"
        ;;
    *)
        hydro_print "--Iris helper deactivated"
        hydro_disable_irishelper
        ;;
    esac
    case $key_click_4 in
    KEY_VOLUMEUP)
        hydro_print "--Iris X7/X7P enhancement activated"
        ;;
    *)
        hydro_print "--Iris X7/X7P enhancement deactivated"
        hydro_disable_pxlw_enhance
        ;;
    esac
    case $key_click_9 in
    KEY_VOLUMEUP)
        case $key_click_10 in
        KEY_VOLUMEUP)
            hydro_print "--Aggressive idle refresh rate strategy activated"
            hydro_refresh_aggressive
            ;;
        *)
            hydro_print "--Idle refresh rate policy disabled"
            hydro_refresh_disable
            ;;
        esac
        ;;
    *)
        hydro_print "--Idle refresh rate modification disabled"
        hydro_refresh_default
        ;;
    esac
    case $key_click_en in
    KEY_VOLUMEUP)
        lang="zh"
        sed -i "s/^description=.*$/description=$DESC_ZH/" "$HYPROP"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    *)
        case $key_click_fr in
        KEY_VOLUMEUP)
            lang="fr"
            sed -i "s/^description=.*$/description=$DESC_FR/" "$HYPROP"
            rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
            rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
            sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
            rm -f "$MODPATH"/请读我.md
            rm -f "$MODPATH"/README.md
            ;;
        *)
            lang="en"
            sed -i "s/^description=.*$/description=$DESC_EN/" "$HYPROP"
            rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
            rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
            sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
            rm -f "$MODPATH"/请读我.md
            rm -f "$MODPATH"/Lis-moi.md
            ;;
        esac
    esac
}

hydro_pre_install(){
    hydro_device_support
    hydro_cloud_process_new
    hydro_iris_cfg_update
    hydro_soc_detect
    hydro_environment_detection
    hydro_cure_select
}

hydro_after_install(){
    hydro_ksu_support
    hydro_injection
    set_perm_recursive "$MODPATH" 0 0 0755 0644
    set_perm "$MODPATH"/joy_config/sqlite3 0 0 0755
    set_perm "$MODPATH"/iris/iris_helper.sh 0 0 0755
    set_perm "$MODPATH"/iris/iris_configs.xml 0 0 0755
    set_perm "$MODPATH"/real_batt 0 0 0755
    set_perm_recursive "$MODPATH"/system/vendor 0 0 0755 0644 u:object_r:vendor_configs_file:s0
}

hydro_start_install(){
    key_click_0=""
    key_click_1=""
    key_click_2=""
    key_click_3=""
    key_click_4=""
    key_click_5=""
    key_click_6=""
    key_click_7=""
    key_click_8=""
    key_click_9=""
    key_click_10=""
    key_click_en=""
    key_click_fr=""
    hydro_language_select
    hydro_pre_install
    if [ "$android_version" = "14" ]; then
        hydro_hyper_os
    else
        hydro_vibration_install #1
    fi
    if [ "$soc" = "mt6989" -o "$soc" = "mt6985" -o "$soc" = "mt6895" -o "$soc" = "mt6983" -o "$soc" = "mt6896" ]; then
        hydro_soundfx_install #2, 8
    else
        hydro_disable_soundfx
        key_click_2="KEY_VOLUMEDOWN"
        key_click_8="KEY_VOLUMEDOWN"
    fi
    if [ "$soc" = "mt6985" ]; then
        hydro_pxlw_enhance_install #4
        hydro_iris_install #7
    else
        hydro_disable_irishelper
        hydro_disable_pxlw_enhance
        key_click_4="KEY_VOLUMEDOWN"
        key_click_7="KEY_VOLUMEDOWN"
    fi
    hydro_vrr_install #9, 10
    hydro_perfopt_install #6
    if pm list packages | grep -q '^package:com.miHoYo.'; then
        hydro_ysvk_install #5
    fi
    hydro_sfopt_install #0
    hydro_install_completed
    hydro_settings_backup
    hydro_after_install
}

if [ -f "/data/adb/modules/ab_optimizer/settings.txt" ]; then
    hydro_read_settings
    old_settings_apply_go=1
elif [ -f "/data/adb/modules_update/ab_optimizer/settings.txt" ]; then
    settings_old=/data/adb/modules_update/ab_optimizer/settings.txt
    hydro_read_settings
    old_settings_apply_go=1
else
    old_settings_apply_go=0
fi

if [ $old_settings_apply_go = 1 ]; then
    case $key_click_en in
    KEY_VOLUMEUP)
        lang="zh"
        ;;
    *)
        case $key_click_fr in
        KEY_VOLUMEUP)
            lang="fr"
            ;;
        *)
            lang="en"
            ;;
        esac
    esac
    case $lang in
    zh)
        print_line
        hydro_print "检测到本模块的旧有配置"
        hydro_print "是否一键调用？"
        hydro_print "音量键 + : 是"
        hydro_print "音量键 - : 否"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        rm -f "$MODPATH"/README.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    fr)
        print_line
        hydro_print "Une configuration existante a été détectée"
        hydro_print "Voulez-vous l'appliquer en un clic?"
        hydro_print "Volume + : Oui"
        hydro_print "Volume - : Non"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_en.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/README.md
        ;;
    *)
        lang="en"
        print_line
        hydro_print "An existing configuration has been detected"
        hydro_print "Do you want to apply it with one click?"
        hydro_print "Volume + : Yes"
        hydro_print "Volume - : No"
        rm -f "$MODPATH"/iris/iris_helper_user_guide_zh.md
        rm -f "$MODPATH"/iris/iris_helper_user_guide_fr.md
        sed -i "s/Hydrostellaire 沨莹/Hydrostellaire/g" "$HYPROP"
        rm -f "$MODPATH"/请读我.md
        rm -f "$MODPATH"/Lis-moi.md
        ;;
    esac
    if [ "$hydro_old_flag" != "1" ]; then
        while [ "$key_click_a" = "" ]; do
            key_click_a=$(getevent -qlc 1 | awk '{ print $3 }' | grep 'KEY_')
            sleep 0.2
        done
        print_line
        case $key_click_a in
        KEY_VOLUMEUP)
            hydro_pre_install
            hydro_apply_settings
            cp $settings_old /data/adb/modules_update/ab_optimizer
            ;;
        *)
            hydro_print "--Reinstall"
            hydro_start_install
            ;;
        esac
    fi
else
    hydro_start_install
fi