#!/system/bin/sh
MODDIR="/data/adb/modules/ab_optimizer/iris"
config_file="$MODDIR/iriscfgcustomize.conf"
df_file="/data/system/mcd/df"
pfmgr_mtk="/sys/module/perfmgr_mtk/parameters"
timer=2.5

> "$df_file" && chmod 644 "$df_file"

ihelper_getTopApp(){
  name_app=$(dumpsys activity activities|grep topResumedActivity=|tail -n 1|cut -d "{" -f2|cut -d "/" -f1|cut -d " " -f3)
}

ihelper_readBlock(){
  local line_numrb=-1
  pfmgr_enable=""
  f_t_fps=""
  df_param=""
  params_a=""
  params_b=""
  params_c=""
  params_d=""
  pfmgr_pwsave=""
  while read -r liner; do
    line_numrb=$((line_numrb + 1))
    if [ $line_numrb -eq $1 ]; then
      local value=${liner#*: }
      case "$liner" in
      params_a:*)
        params_a=$value
        ;;
      params_b:*)
        params_b=$value
        ;;
      params_c:*)
        params_c=$value
        ;;
      params_d:*)
        params_d=$value
        ;;
      df:*)
        df_param=$value
        ;;
      pfmgr_enable:*)
        pfmgr_enable=$value
        ;;
      f_t_fps:*)
        f_t_fps=$value
        ;;
      pfmgr_pwsave:*)
        pfmgr_pwsave=$value
        ;;
      app:*)
        break
        ;;
      END)
        break
        ;;
      esac
    fi
  done < "$config_file"
}

ihelper_getParams(){
  ihelper_found_ta=0
  line_number=0
  while read -r lineg; do
    line_number=$((line_number + 1))
    if [ "$lineg" = "app: \"$1\"" ]; then
      ihelper_found_ta=1
      break
    elif [ "$lineg" = "END" ]; then
      break
    fi
  done < $config_file
  if [ $ihelper_found_ta -eq 1 ]; then
    ihelper_readBlock "$line_number"
    ihelper_process
  else
    ihelper_default
  fi
}

ihelper_default(){
  /odm/bin/irisConfig 47 1 0
  /odm/bin/irisConfig 258 1 0
  /odm/bin/irisConfig 267 2 3 0
  /odm/bin/irisConfig 273 1 0
  > "$df_file"
  echo 0 > "$pfmgr_mtk/perfmgr_enable"
  echo -1 > "$pfmgr_mtk/fixed_target_fps"
  echo "N" > "$pfmgr_mtk/powersave"
}

ihelper_process(){
  if [ -n "$params_a" ]; then
    /odm/bin/irisConfig $params_a
  fi
  if [ -n "$params_b" ]; then
    /odm/bin/irisConfig $params_b
  fi
  if [ -n "$params_c" ]; then
    /odm/bin/irisConfig $params_c
  fi
  if [ -n "$params_d" ]; then
    /odm/bin/irisConfig $params_d
  fi
  if [ -n "$df_param" ]; then
    echo "$name_app $df_param" > "$df_file"
  fi
  if [ -n "$pfmgr_enable" ]; then
    echo "$pfmgr_enable" > "$pfmgr_mtk/perfmgr_enable"
  fi
  if [ -n "$f_t_fps" ]; then
    echo "$f_t_fps" > "$pfmgr_mtk/fixed_target_fps"
  fi
  if [ -n "$pfmgr_pwsave" ]; then
    echo "$pfmgr_pwsave" > "$pfmgr_mtk/powersave"
  fi
}

wait_until_boot_complete() {
  while [ "$(getprop sys.boot_completed)" != "1" ]; do
    sleep 1
  done
}

wait_until_boot_complete

while true; do
  ihelper_getTopApp
  if [ "$name_app" != "$current_app" ]; then
    ihelper_getParams "$name_app"
    current_app="$name_app"
  fi
  sleep "$timer"
done