#!/system/bin/sh
MODDIR="/data/adb/modules/ab_optimizer/iris"
config_file="$MODDIR/iriscfgcustomize.conf"
timer=2.5

ihelper_getTopApp(){
  name_app=$(dumpsys activity activities|grep topResumedActivity=|tail -n 1|cut -d "{" -f2|cut -d "/" -f1|cut -d " " -f3)
}

ihelper_readBlock(){
  params_a=""
  params_b=""
  params_c=""
  params_d=""
  adfr_n=""
  local line_numrb=-1
  while read -r liner; do
    line_numrb=$((line_numrb + 1))
    if [ $line_numrb -ge $1 ]; then
      local value=${liner#*: }
      case "$liner" in
        params_a:*)
          params_a=$value
          ;;
        params_b:*)
          params_b=$value
          ;;
        params_c:*)
          params_c=$value
          ;;
        params_d:*)
          params_d=$value
          ;;
        adfr_n:*)
          adfr_n=$value
          ;;
        app:*)
          break
          ;;
        END)
          break
          ;;
      esac
    fi
  done < "$config_file"
}

ihelper_getParams(){
  ihelper_found_ta=0
  line_number=0
  while read -r lineg; do
    line_number=$((line_number + 1))
    if [ "$lineg" = "app: \"$1\"" ]; then
      ihelper_found_ta=1
      break
    elif [ "$lineg" = "END" ]; then
      break
    fi
  done < "$config_file"
  if [ $ihelper_found_ta -eq 1 ]; then
    ihelper_readBlock $line_number
    ihelper_process
  else
    ihelper_default
  fi
}

ihelper_default(){
  /odm/bin/irisConfig 47 1 0
  /odm/bin/irisConfig 258 1 0
  /odm/bin/irisConfig 267 2 3 0
  /odm/bin/irisConfig 273 1 0
  echo "$adfr_default" > /sys/kernel/oplus_display/adfr_config
}

ihelper_process(){
  if [ -n "$params_a" ]; then
    /odm/bin/irisConfig $params_a
  fi
  if [ -n "$params_b" ]; then
    /odm/bin/irisConfig $params_b
  fi
  if [ -n "$params_c" ]; then
    /odm/bin/irisConfig $params_c
  fi
  if [ -n "$params_d" ]; then
    /odm/bin/irisConfig $params_d
  fi
  if [ -n "$adfr_n" ]; then
    echo "0x0" > /sys/kernel/oplus_display/adfr_config
  fi
}

wait_until_boot_complete() {
  while [ "$(getprop sys.boot_completed)" != "1" ]; do
    sleep 1
  done
}

wait_until_boot_complete
adfr_default=$(cat /sys/kernel/oplus_display/adfr_config)
sleep 5

while true; do
  ihelper_getTopApp
  if [ "$name_app" != "$current_app" ]; then
    ihelper_getParams "$name_app"
    current_app="$name_app"
  fi
  sleep "$timer"
done