#Iris Helper by Aestas_Britannia
#The module is not allowed for any commercial use

Configuration format:
app: "package_name"
params_a: Type-ID params_amount param0 param1 param2 etc.
params_b: Type-ID params_amount param0 param1 param2 etc.
......
params_d: Type-ID params_amount param0 param1 param2 etc.
df: value
pfmgr_enable: 0/1
f_t_fps: value
pfmgr_pwsave: Y/N

The file should end with:
END

--------

First example:
app: "com.tencent.tmgp.sgame"
params_a: 258 6 40 -1 34 -1 3 60

Among them, 258 is the Type-ID of this instruction, which is MEMC/HDR.
params_amount is the total number of subsequent params
That is, 40, -1, 34,-1, 3, 60, a total of 6 parameters, the meaning is:
40: Enable Dual MEMC
34: Low latency, normal gaming
3: Use Genshin Impact presets
60: Original frame rate is 60
-1: Placeholder, this position has no actual effect
The specific number of params to write can depend on your needs. Unfilled positions will be automatically set to 0
For game content, a fixed format of 6 params is generally used, that is, 258 6 10 -1 * -1 * *
For video content, a fixed format of 3 params is generally used, that is, 258 3 10 0 0

For Param2 in Type 258, its 0~3 bits (bit 0~3) are a binary number
You need to convert it into a four-digit binary number (binary numbers are composed of 0 and 1)
To convert a decimal input into a four-digit binary number, you only need to follow the "8421" principle.
For the decimal number 3, we have:
3 = 0x8 + 0x4 + 1x2 + 1x1
That is 3 → 0011
Similarly, 6 = 0x8 + 1x4 + 1x2 + 0x1
That is 6 → 0110

Suppose you need to enable eMV game mode 2, which is the mode represented by the decimal number 4
According to the above method, its binary number can be obtained
4 → 0100
Now, repeat the above steps for the next four digits
Assuming you need ultra-low latency (represented by the number 3), convert this to binary:
3 → 0011
Now, you have obtained eight digits
Repeat the above process until you get all the parameters you need
If not needed, you can ignore the extra bits and they will be set to 0
Arrange them from high to low:
00110100
Use the opposite method to convert it to a decimal number
For a sixteen-bit binary number, the bit weight of each bit is:
32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1
Therefore
00110100 → 32+16+4 = 52
Get the number 52
Therefore, the Param 2 you need is 52

Generally speaking, the commonly used Param 2 is one of 18, 34, or 50, corresponding to:
18: Normal latency gaming
34: Low latency gaming
50: Ultra-low latency gaming
The lower the delay, the more defects the picture will have; the higher the delay, the more coherent the picture will be.
Usually, the delay introduced by frame insertion is not high; the main factor causing the increase in delay is that the original frame rate of the game is reduced. For example, OnePlus will lock 40 frames for some games and then increase it to 120.

Generally speaking, do not fill in 0 in Param 5 to automatically match the frame rate
Filling in specific values ​​will help improve the frame insertion effect

Notice! Do not enable MEMC for games that support IRX rendering acceleration technology, that is, games that provide the "Independent graphics acceleration 120 frames" option in the game!

--------

Let’s look at another example:
app: "com.tencent.tmgp.sgame"
params_b: 273 3 1 3 1

Among them, 273 is the Type-ID of this instruction, which is the type, and SR is the super resolution.
params_amount is the total number of subsequent params
That is, 1, 3, 1, a total of 3 parameters, the meaning is:
1: Enable SR
3: Use Genshin Impact presets
1: Use LPSR

For games that do not have independent presets, generally use the 255 preset, which is the universal preset, otherwise it may not take effect due to resolution mismatch.
For X7 Gen 2, the power consumption of LPSR is about 0.3 W, and the power consumption of HESR is about 0.5~0.6 W; for X7, the power consumption of SR can be basically ignored

In the above examples, only one set of parameters is enabled, namely params_a or params_b
In actual use, up to 4 sets of parameters can be enabled at the same time
Any Type-ID can be filled in any params_* without considering the order.

--------

If you want to release the video frame interpolation that comes with the system, or use the frame interpolation and super-resolution settings controlled by the game assistant
You need to add the package name of the corresponding application in the configuration file of Iris Helper, and do not add any params

--------

For Yuni Kernel, the module supports modifying FEAS parameters.
Enable FEAS while pfmgr_enable: 1
Enable powersave mode for FEAS while pfmgr_pwsave: Y
Set target FPS for FEAS while f_t_fps exists
Lock max FPS at df while it exists
If there's only a package name without any params for the app,
the module will apply presets in booster_config_mtk.json instead resetting params to default.

--------

Here's the types of Iris_x7 parameters:
For the modified settings of this module, please refer to the Chinese help document of this module.

--------

MEMC - HDR Formal Solution:
Type: 258  Feature: Enable/Disable MEMC/HDR
Param 0: mode setting
0	 Disable HDR
2	 Enable HDR (Unavailable for X7 Gen 2)
10	 Enable single MEMC
14	 Enable TNR (Unavailable for X7 Gen 2)
40	 Enable dual MEMC (Unavailable for X7 Gen 2)

Param 1: Ignored
-1	 Ignored

Param 2: scene setting
- MEMC scene	 Bit0~3
0	 normal video
1	 MMI test
2	 normal game
3	 eMV game mode 1
4	 eMV game mode 2
5	 short video
6	 eMV API allowed
- low latency mode	 Bit4~7
0	 disable low latency
1	 normal latency
2	 low latency
3	 ultra-low latency
- MEMC level	 Bit8~11
0	 level0
- N2M mode	 Bit12~15
0	 disable N2M
1	 enable N2M
- reserved	 Bit16~31

Param 3: Ignored
-1	 Ignored

Param 4: Game app list (Configurated in /odm/etc/iris_config.xml)
0	 HePingJingYing
1	 WanMeiShiJie
2	 TianDao
3	 YuanShen
4	 BengHuai3
5	 GuiQi
6	 TianYu
7	 ZhanShenYiJi
8	 DiWuRenGe
9	 TBD
100	 BuLuoChongTu(WaiXiaoJiXing)
101	     ShiMingZhaoHuan(WaiXiaoJiXing)
102	 YuanShen(WaiXiaoJiXing)

Param 5: Game fps
0	 Auto
30	 30fps
45	 45fps
60	 60fps

Param 6: HePingJingYingSighting
0	 Off(default)
1	 HePingJingYingZhunXing
2	 HePingJingYingQuanXi

--------

SDR2HDR:
Type: 267	Feature: Set SDR2HDR Setting (Only color gamut for X7 Gen 2)

Param 0: Setting Type
3	 Pre-defined SDR2HDR setting (Recommended) 
5    Pre-defined game App EDR setting

Param 1: Pre-defined Setting (Configurated in /odm/etc/iris_config.xml)
0	 All off 
1	 Video (Recommended)
2	 Enhanced video 
3	 Game 
4	 Low power video 
10	 Dark area brightening filter 
11	 Anti-snow blindness filter 
12	 movie mode
13	 vivid mode
14	 bright mode 
15	 gentle mode 
16	 LOL 
17	 YuanShen 
18	 HePingJingYing 
19	 WangZheRongYao 
20	 Revelation style 
21	 GunsGirl style 
22	 Identity-V style 
23	 Onmyoji style 

--------

SR: The SR feature works in PT mode.
Type: 273	Feature: Set SR Setting

Param 0: Setting Type
0	 Disable SR (Recommended)
1	 Enable  SR 

Param 1: Game App list (Configurated in /odm/etc/iris_config.xml)
0	 HePingJingYing 
1	 WanMeiShiJie 
2	 TianDao 
3	 YuanShen 
4	 BengHuai3 
5	 GuiQi 
6	 TianYu 
7	 ZhanShenYiJi 
8	 DiWuRenGe 
9	 TBD 
100	 BuLuoChongTu(WaiXiaoJiXing)
101	     ShiMingZhaoHuan(WaiXiaoJiXing)
102	 YuanShen(WaiXiaoJiXing)

Param 2: SR Mode (X7 Gen2 only)
0	 LPSR (Low Power Super Resolution)
1    HESR (High Efficiency Super Resolution)

--------

HDR:
Type: 47 	Feature: HDR mode (Unavailable for X7 Gen 2)
Param 0: HDR mode
0	 Disable (Recommended)
61	 HLG HDR
62	 HDR10
3	 Online video
4	 Short video
5	 Local video
6	 Gallery photo
7	 Game
8	 Reading
9	 AI Online video
10	 AI Short video
11	 AI Local video
12	 AI Gallery photo
13	 AI Game
14	 AI Reading

--------