#Iris Helper by Aestas_Britannia
#Le module n'est pas autorisé pour toute utilisation commerciale

Format de configuration:
app: "nom du package"
params_a: Type-ID nombre_des_paramètres param0 param1 param2...
params_b: Type-ID nombre_des_paramètres param0 param1 param2...
......
params_d: Type-ID nombre_des_paramètres param0 param1 param2...
df: valeur
pfmgr_enable: 0/1
f_t_fps: valeur
pfmgr_pwsave: Y/N

Le fichier doit se terminer par :
END

---------

Premier exemple :
application : "com.tencent.tmgp.sgame"
params_a : 258 6 40 -1 34 -1 3 60

Parmi eux, 258 est le Type-ID de cette instruction, qui est MEMC/HDR.
params_amount est le nombre total de paramètres suivants
C'est-à-dire 40, -1, 34,-1, 3, 60, un total de 6 paramètres, la signification est :
40 : Activer le double MEMC
34 : Faible latence, jeu normal
3 : Utilisez les préréglages Genshin Impact
60 : la fréquence d'images d'origine est de 60
-1 : Espace réservé, cette position n'a aucun effet réel
Le nombre spécifique de paramètres à écrire peut dépendre de vos besoins. Les postes non pourvus seront automatiquement mis à 0
Pour le contenu du jeu, un format fixe de 6 paramètres est généralement utilisé, soit 258 6 10 -1 * -1 * *
Pour le contenu vidéo, un format fixe de 3 paramètres est généralement utilisé, soit 258 3 10 0 0

Pour Param2 du type 258, ses bits 0~3 (bits 0~3) sont un nombre binaire
Vous devez le convertir en un nombre binaire à quatre chiffres (les nombres binaires sont composés de 0 et 1)
Pour convertir une entrée décimale en un nombre binaire à quatre chiffres, il vous suffit de suivre le principe « 8421 ».
Pour le nombre décimal 3, on a :
3 = 0x8 + 0x4 + 1x2 + 1x1
Soit 3 → 0011
De même, 6 = 0x8 + 1x4 + 1x2 + 0x1
Soit 6 → 0110

Supposons que vous deviez activer le mode de jeu eMV 2, qui est le mode représenté par le nombre décimal 4.
Selon la méthode ci-dessus, son nombre binaire peut être obtenu
4 → 0100
Maintenant, répétez les étapes ci-dessus pour les quatre chiffres suivants
En supposant que vous ayez besoin d'une latence ultra-faible (représentée par le chiffre 3), convertissez ceci en binaire :
3 → 0011
Maintenant, vous avez obtenu huit chiffres
Répétez le processus ci-dessus jusqu'à ce que vous obteniez tous les paramètres dont vous avez besoin
S'ils ne sont pas nécessaires, vous pouvez ignorer les bits supplémentaires et ils seront mis à 0
Disposez-les de haut en bas :
00110100
Utilisez la méthode inverse pour le convertir en nombre décimal
Pour un nombre binaire de seize bits, le poids de chaque bit est :
32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1
Donc
00110100 → 32+16+4 = 52
Obtenez le numéro 52
Par conséquent, le Param 2 dont vous avez besoin est 52

De manière générale, le paramètre 2 couramment utilisé est l'un des 18, 34 ou 50, correspondant à :
18 : Jeu à latence normale
34 : Jeu à faible latence
50 : Jeu à latence ultra faible
Plus le délai est faible, plus l'image aura de défauts ; plus le délai est élevé, plus l'image sera cohérente.
Habituellement, le retard introduit par l’insertion d’une trame n’est pas élevé ; le principal facteur à l'origine de l'augmentation du délai est que la fréquence d'images d'origine du jeu est réduite. Par exemple, OnePlus verrouille 40 images pour certains jeux, puis l'augmente à 120.

De manière générale, ne remplissez pas 0 dans le paramètre 5 pour correspondre automatiquement à la fréquence d'images
Remplir des valeurs spécifiques aidera à améliorer l'effet d'insertion de cadre

Avis! N'activez pas MEMC pour les jeux prenant en charge la technologie d'accélération du rendu IRX, c'est-à-dire les jeux qui fournissent l'option « Accélération graphique indépendante 120 images » dans le jeu !

---------

Regardons un autre exemple :
application : "com.tencent.tmgp.sgame"
params_b : 273 3 1 3 1

Parmi eux, 273 est le Type-ID de cette instruction, qui est le type, et SR est la super résolution.
params_amount est le nombre total de paramètres suivants
C'est-à-dire 1, 3, 1, un total de 3 paramètres, la signification est :
1 : Activer SR
3 : Utilisez les préréglages Genshin Impact
1 : Utiliser LPSR

Pour les jeux qui n'ont pas de préréglages indépendants, utilisez généralement le préréglage 255, qui est le préréglage universel, sinon il risque de ne pas prendre effet en raison d'une inadéquation de résolution.
Pour le X7 Gen 2, la consommation électrique du LPSR est d'environ 0,3 W et la consommation électrique du HESR est d'environ 0,5 à 0,6 W ; pour X7, la consommation électrique de SR peut être fondamentalement ignorée

Dans les exemples ci-dessus, un seul ensemble de paramètres est activé, à savoir params_a ou params_b
En utilisation réelle, jusqu'à 4 jeux de paramètres peuvent être activés en même temps
N'importe quel Type-ID peut être rempli dans n'importe quel params_* sans tenir compte de l'ordre.

---------

Si vous souhaitez libérer l'interpolation d'image vidéo fournie avec le système, ou utiliser les paramètres d'interpolation d'image et de super-résolution contrôlés par l'assistant de jeu
Vous devez ajouter le nom du package de l'application correspondante dans le fichier de configuration d'Iris Helper, et n'ajouter aucun paramètre

---------

Pour le kernel Yuni, le module prend en charge la modification des paramètres FEAS.
Activer FEAS lorsque pfmgr_enable: 1
Activer le mode powersave pour FEAS lorsque pfmgr_pwsave: Y
Définir le FPS cible pour FEAS lorsque f_t_fps existe
Verrouiller le FPS max à df lorsque cela existe
Si il n'y a qu'un nom de package sans aucun paramètre pour l'application,
le module appliquera les réglages par défaut dans booster_config_mtk.json au lieu de réinitialiser les paramètres par défaut.

--------

Voici les types de paramètres d'Iris_x7 :
Pour les paramètres modifiés de ce module, veuillez vous référer au document d'aide chinois de ce module.


---------

MEMC - Solution formelle HDR :
Type : 258 Fonctionnalité : Activer/Désactiver MEMC/HDR
Paramètre 0 : réglage du mode
0 Désactiver le HDR
2 Activer HDR (non disponible pour X7 Gen 2)
10 Activer un seul MEMC
14 Activer TNR (non disponible pour X7 Gen 2)
40 Activer le double MEMC (non disponible pour X7 Gen 2)

Paramètre 1: Ignoré
-1	 Ignored

Paramètre 2 : mise en scène
- Scène MEMC Bit0~3
0 Vidéo normale
1 Test MMI
2 Jeux normaux
3 Mode de jeu eMV 1
4 Mode de jeu eMV 2
5 Courtes vidéos
6 API eMV autorisées
- Mode faible latence Bit4 ~ 7
0 Désactive la faible latence
1 Latence normale
2 Faible latence
3 Latence ultra faible
- Niveau MEMC Bit8 ~ 11
0 Niveau0
- Mode N2M Bit12 ~ 15
0 Désactiver N2M
1 Activer N2M
- Bit16 ~ 31 Réservé

Paramètre 3 : Ignoré
-1 ignoré

Paramètre 4 : Liste des applications de jeu (configurée dans /odm/etc/iris_config.xml)
0	 HePingJingYing
1	 WanMeiShiJie
2	 TianDao
3	 YuanShen
4	 BengHuai3
5	 GuiQi
6	 TianYu
7	 ZhanShenYiJi
8	 DiWuRenGe
9	 TBD
100	 BuLuoChongTu(WaiXiaoJiXing)
101	     ShiMingZhaoHuan(WaiXiaoJiXing)
102	 YuanShen(WaiXiaoJiXing)

Paramètre 5 : Fps du jeu
0	 Auto
30	 30fps
45	 45fps
60	 60fps

Paramètre 6: HePingJingYingSighting
0	 Off(default)
1	 HePingJingYingZhunXing
2	 HePingJingYingQuanXi

--------

SDR2HDR :
Type : 267 Caractéristique : Définir le paramètre SDR2HDR (uniquement la gamme de couleurs pour X7 Gen 2)

Paramètre 0 : Type de réglage
3 paramètres SDR2HDR prédéfinis (recommandé)
5 paramètres EDR de l'application de jeu prédéfinie

Paramètre 1 : Paramètre prédéfini (configuré dans /odm/etc/iris_config.xml)
0 Tout est éteint
1 Vidéo (recommandée)
2 Vidéo améliorée
3 Jeu
4 Vidéo basse consommation
10 Filtre éclaircissant pour zones sombres
11 Filtre anti-cécité des neiges
12 Modes cinéma
13 Modes vifs
14 Modes lumineux
15 Modes doux
16 MDR
17 YuanShen
18 HePingJingYing
19 WangZheRongYao
20 Style Révélation
21 Style GunsGirl
22 Style Identité-V
23 Style Onmyoji

--------

SR : La fonction SR fonctionne en mode PT.
Type : 273 Caractéristique : Définir le paramètre SR

Paramètre 0 : Type de réglage
0 Désactiver SR (recommandé)
1 Activer SR

Paramètre 1 : Liste des applications de jeu (configurée dans /odm/etc/iris_config.xml)
0	 HePingJingYing 
1	 WanMeiShiJie 
2	 TianDao 
3	 YuanShen 
4	 BengHuai3 
5	 GuiQi 
6	 TianYu 
7	 ZhanShenYiJi 
8	 DiWuRenGe 
9	 TBD 
100	 BuLuoChongTu(WaiXiaoJiXing)
101	 ShiMingZhaoHuan(WaiXiaoJiXing)
102	 YuanShen(WaiXiaoJiXing)

Paramètre 2 : Mode SR (X7 Gen2 uniquement)
0 LPSR (Super résolution basse consommation)
1 HESR (Super résolution haute efficacité)

--------

HDR :
Type : 47 Fonctionnalité : Mode HDR (non disponible pour X7 Gen 2)
Paramètre 0 : mode HDR
0 Désactiver (recommandé)
61 HLG HDR
62 HDR10
3 Vidéo en ligne
4 Courte vidéo
5 Vidéo locale
6 Galerie de photos
7 Jeu
8 Lecture
9 Vidéo IA en ligne
10 Courte vidéo sur l'IA
11 Vidéo locale IA
12 Photo de la galerie IA
13 Jeu IA
14 Lecture IA

--------