#Iris Helper by Aestas_Britannia
#本模块不允许任何商业用途

配置文件格式：
app: "package_name"
params_a: Type-ID params_amount param0 param1 param2 等等
params_b: Type-ID params_amount param0 param1 param2 等等
......
params_d: Type-ID params_amount param0 param1 param2 等等
df: 数值
pfmgr_enable: 0/1
f_t_fps: 数值
pfmgr_pwsave: Y/N
文件应该以以下内容结束：
END

--------

第一个例子：
app: "com.tencent.tmgp.sgame"
params_a: 258 6 40 -1 34 -1 3 60

其中，258 为这条指令的 Type-ID 即类型，为 MEMC/HDR
params_amount 为后面 param 的总数量
即 40, -1, 34 ,-1, 3, 60 共 6 个参数，含义为：
40: 启用 Dual MEMC
34: 低延迟，普通游戏
3: 使用原神预设
60: 原始帧率为 60
-1: 占位符，该位置无实际作用
具体写入多少个 param 可以取决于你的需求，不填写的位置会被自动设置为 0
对于游戏内容，一般采用 6 个 param 的固定格式，即 258 6 10 -1 * -1 * *
对于视频内容，一般采用 3 个 param 的固定格式，即 258 3 10 0 0

对于 Type 258 中的 Param2，它的第0~3位（bit 0~3）是一个二进制数字
你需要将它转化为四位二进制数（二进制数由0和1组成）
将一个十进制输转化为四位二进制数，只需要按“8421”的原则即可
对于十进制数3，有：
3 =  0x8 + 0x4 + 1x2 + 1x1
即 3 → 0011
同理，6 = 0x8 + 1x4 + 1x2 + 0x1
即 6 → 0110

假设你需要启用eMV 游戏模式 2，即十进制数 4 所代表的模式
根据上面的方法可以得到它的二进制数
4 → 0100
现在，对接下来的四位重复以上步骤
假设你需要超低延迟（由数字3代表），将它转化为二进制：
3 → 0011
现在，你已经获得了八位数字
重复以上流程，直至你获得你所需要的全部参数
如果不需要，你可以无视多余的位，它们会被设置为0
将它们从高到低排列：
00110100
用相反的方法将它转化为十进制数
对于十六位的二进制数，每一位的位权分别是：
32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1
故
00110100 → 32+16+4 = 52
得到数字 52
因此，你所需要的 Param 2 为 52

一般而言，常用的 Param 2 为 18, 34, 50 其中的一个，分别对应：
18: 普通延迟游戏
34: 低延迟游戏
50: 超低延迟游戏
延迟越低，画面瑕疵越多；延迟越高，画面越连贯
通常，超帧引入的延迟不高；导致延迟增加的主要因素在于游戏的原始帧率被降低，例如一加会为部分游戏锁40帧再插至120

一般来讲，不要在 Param 5 填入 0 来自动匹配帧率
填入具体的数值有助于提升插帧效果

注意！不要对支持 IRX 渲染加速技术的游戏，即游戏内提供“独显加速120帧”选项的游戏启用 MEMC！

--------

再看另一个示例：
app: "com.tencent.tmgp.sgame"
params_b: 273 3 1 3 1

其中，273 为这条指令的 Type-ID 即类型，为 SR 即超分辨率
params_amount 为后面 param 的总数量
即 1, 3, 1 共 3 个参数，含义为：
1: 启用 SR
3: 使用 原神 预设
1: 使用 LPSR

对于没有独立预设的游戏，一般采用 255 预设即通用预设，否则可能会因分辨率不匹配而不生效
对于 X7 Gen 2，LPSR 的功耗在 0.3 W 左右，HESR 的功耗在 0.5～0.6 W左右；对于 X7，SR 的功耗可基本忽略

以上示例中均仅启用了一组参数，即 params_a 或 params_b
实际使用中可同时启用多至 4 组参数
任何一种 Type-ID 均可以填在任意一个 params_* 中，不需要考虑 Type-ID 的先后顺序
但配置文件的参数顺序（params_a,b,c,d, df, ..., pfmgr_pwsave）需要固定

--------

如果你想要放行系统自带的视频插帧，或者使用游戏助手控制的插帧和超分辨率设置
你需要在 Iris Helper 的配置文件内添加对应应用的包名，并且不添加任何 params

--------

对于Yuni内核，本模块支持调整FEAS参数：
启用FEAS当pfmgr_enable为1
启用省电模式当pfmgr_pwsave为Y
设置目标帧率至f_t_fps
将游戏最大渲染帧率锁至df
如果你只配置了包名，或者某些参数为空，那么对于未配置的参数，本模块会放行booster_config_mtk.json中的参数

--------

下面是Iris_x7参数的类型：
注意，以下参数并不在默认状态下通用
具体情况请参阅设备 /odm/etc/iris_configs.xml

--------

MEMC - HDR 方案:
Type:258 	特性: 启用/禁用 MEMC/HDR
Param 0: 模式设置
0	 禁用 HDR
2	 启用 HDR（不支持 X7 Gen 2）
10	 启用 single MEMC
14	 启用 TNR（不支持 X7 Gen 2）
40	 启用 dual MEMC（不支持 X7 Gen 2）

Param 1: 忽略
-1	 忽略

Param 2: 场景设置
- MEMC 场景	 Bit0~3
0	 普通视频
1	 MMI 测试
2	 普通游戏（推荐）
3	 eMV 游戏模式 1
4	 eMV 游戏模式 2
5	 短视频
6	 允许 eMV API
- 低延迟模式	 Bit4~7
0	 OSD 模式
1	 普通延迟
2	 低延迟
3	 超低延迟
- MEMC 级别	 Bit8~11
0	 级别0
- N2M 模式	 Bit12~15
0	 禁用 N2M
1	 启用 N2M
- 保留	 Bit16~31

#注：eMV 的全称可能是enhanced Motion Vector，与iMV（improved）相对应
#例：Param 2有效值
#18    普通延迟
#34    低延迟
#50    超低延迟
#2    OSD 模式

Param 3: 忽略
-1	 忽略

#注：游戏编号和具体的预设编号参见 iris_configs.xml，以下仅为示例

Param 4: 游戏清单（游戏预设编号）
0,5,13,15	 OSD-和平精英
1	 OSD-完美世界
2,3,4,8,9,10,11,12,14,16,17,20,21,22,23,24,25,155	 禁用 OSD
28,30,35,36,41,48,49,50,53,55,57,59,71,74,81,82,86,88,90,106,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,147,148,149,150,151,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,254	 默认 OSD

Param 5: 游戏帧率
0	 自动（默认）
30	 30fps
45	 45fps
60	 60fps
...

#注：你可以填入任意原始帧率

Param 6: 和平精英准星
0	 关闭（默认）
1	 和平精英准星
2	 和平精英全息

--------

SDR转HDR:
Type: 267	Feature: 配置 SDR转HDR 设置

Param 0: 设置种类
3	 预设 SDR2HDR 设置
4	 预设 SDR2HDR 设置，但 Param 1 为游戏编号
5    预设 EDR 设置，Param 1 为游戏编号

#注：游戏编号和具体的预设编号参见 iris_configs.xml，以下仅为示例

Param 1: 预设设置
0	 全部关闭
1	 视频（推荐）
2	 增强视频
3	 游戏 
4	 低功耗视频 
5    低功耗游戏
7    低功耗APL
8    日光场景
10	 游戏模式鲜艳
11	 游戏模式明亮
12	 游戏模式明艳
13	 生动模式
14	 明亮模式
15	 温和模式
47    尘白禁区
48    原神（推荐）
49    原神（保守）
50    原神（明亮）
54    少女前线2
55    星穹铁道
56    王者荣耀

Param 2: ？
0~100   ？（默认100）

--------

SR: 超分辨率
Type: 273	特性：配置 SR 设置

Param 0: 设置种类
0	 关闭SR（推荐）
1	 启用SR

#注：游戏编号和具体的预设编号参见 iris_configs.xml，以下仅为示例

Param 1: 游戏清单
0	 和平精英
2	 天涯明月刀
3	 原神 
4	 崩坏3
8	 第五人格 
9	 QQ飞车
10   王者荣耀
11    光遇
13   穿越火线手游
16   英雄联盟手游
101    使命召唤手游
155    星穹铁道
200    尘白禁区
201    少女前线2
255   默认（自动）

Param 2: SR 模式（仅支持 X7 Gen 2）
0	 LPSR（低功耗超分辨率）
1    HESR（高效率超分辨率）

--------

HDR:
Type: 47 	特性：HDR模式 （不支持 X7 Gen 2）
Param 0: HDR 模式
0	 禁用（推荐）
61	 HLG HDR
62	 HDR10
3	 在线视频
4	 短视频
5	 本地视频
6	 相册图片
7	 游戏
8	 阅读
9	 AI 在线视频
10	 AI 短视频
11	 AI 短视频
12	 AI 相册图片
13	 AI 游戏
14	 AI 阅读

--------