MODDIR=${0%/*}
kernel_version=$(uname -r)

gen_teg_json() {
    {
        echo -n '{
  "config_name": "'$1'",
  "group_name": "'$1'",
  "with_model": false,
  "enable": true,
  "version": '$2',
  "params": '
        cat "$3"
        echo -n '
}'
    } >"$MODDIR/generated/teg_$1.json"

    echo "$MODDIR/generated/teg_$1.json"
}

gen_teg_config_sql() {
    {
        echo "insert into rules"
        echo -n "(rule_id, rule_version, rule_module, rule_content) values "
        echo -n "(2147483646, 2147483646, '$1', CAST(readfile('$3') AS TEXT));"
        echo "select changes();"
    } >>$MODDIR/generated/joyose_teg.sql
}

gen_joyose_sql() {
    {
        echo "insert into cloud_config "
        echo -n "(config_name, group_name, enable, version, with_model, params) values "
        echo -n "('$1', '$1', 1, $2, 0, CAST(readfile('$3') AS TEXT));"
        echo "select changes();"
    } >>$MODDIR/generated/joyose_cloud.sql
}

init_joyose_config() {
    mkdir $MODDIR/generated
    JOY_CFG="/data/data/com.xiaomi.joyose/databases/SmartP.db"
    TEG_CFG="/data/data/com.xiaomi.joyose/databases/teg_config.db"
    am force-stop com.xiaomi.joyose
    $MODDIR/sqlite3 $JOY_CFG ".read $MODDIR/cloud_config.sql"
    $MODDIR/sqlite3 $TEG_CFG ".read $MODDIR/teg_rules.sql"
    COMMON_VERSION="2024010101"
    BOOSTER_VERSION="2036010101"
    COMMON_JSON="$MODDIR/common_config.json"
    BOOSTER_JSON="$MODDIR/booster_config_mtk.json"
    TEG_COMMON_JSON="$(gen_teg_json "common_config" "$COMMON_VERSION" "$COMMON_JSON")"
    TEG_BOOSTER_JSON="$(gen_teg_json "booster_config" "$BOOSTER_VERSION" "$BOOSTER_JSON")"
    gen_teg_config_sql "common_config" "$COMMON_VERSION" "$TEG_COMMON_JSON"
    gen_teg_config_sql "booster_config" "$BOOSTER_VERSION" "$TEG_BOOSTER_JSON"
    gen_joyose_sql "common_config" "$COMMON_VERSION" "$COMMON_JSON"
    gen_joyose_sql "booster_config" "$BOOSTER_VERSION" "$BOOSTER_JSON"
    $MODDIR/sqlite3 $TEG_CFG ".read $MODDIR/generated/joyose_teg.sql"
    $MODDIR/sqlite3 $JOY_CFG ".read $MODDIR/generated/joyose_cloud.sql"
    rm -rf $MODDIR/generated
    pm disable com.xiaomi.joyose/com.xiaomi.joyose.cloud.CloudServerReceiver
    am broadcast com.xiaomi.joyose/com.xiaomi.joyose.JoyoseBroadCastReceiver
}
init_joyose_config