MODDIR=${0%/*}

HYPROP="$MODDIR"/module.prop
DESC_ZH_A="检测到缺少 Asoul_opt 或 Extreme GT 模块，请重新安装本模块并重启设备"
DESC_EN_A="Missing Asoul_opt or Extreme GT module. Please reinstall this module and restart device"
DESC_FR_A="Module Asoul_opt ou Extreme GT manquant. Veuillez réinstaller ce module et redémarrer l'appareil"
DESC_ZH_B="检测到 Asoul_opt 模块作者异常，请重新安装本模块并重启设备"
DESC_EN_B="An exception has been detected by the author of the Asoul_opt module. Please reinstall this module and restart the device."
DESC_FR_B="Une exception a été détectée par l'auteur du module Asoul_opt. Veuillez réinstaller ce module et redémarrer l'appareil."

enforce_refresh_rate(){
    sleep 90
    for i in $(seq 3 6); do
        service call SurfaceFlinger 1035 i32 "$i"
    done
}

# Conflict detector
hydro_cure_enforce(){
    if pm list packages | grep -q "xyz.chenzyadb.cu_toolbox"; then
        pm uninstall --user 0 xyz.chenzyadb.cu_toolbox
    fi
    for dir in /data/adb/modules /data/adb/modules_update; do
        for subdir in $(find "$dir" -maxdepth 1 -type d); do
            module_prop="$subdir/module.prop"
            if [ -f "$module_prop" ]; then
                if grep -q -e 'int萌新很新' -e '水竹闲士' "$module_prop"; then
                    rm -rf "$subdir"
                    mkdir "$subdir"
                    touch "$subdir"/remove
                fi
            fi
        done
    done
}

hydro_self_uninstall(){
    touch "$MODDIR"/remove
    rm -rf "$MODDIR"/assets
    rm -rf "$MODDIR"/my_product
    rm -rf "$MODDIR"/odm
    rm -rf "$MODDIR"/system
    rm -rf "$MODDIR"/post_fs_data.sh
}

hydro_integrity_detect(){
    lang=$(getprop persist.sys.locale | cut -d '-' -f 1)
    case $lang in
    zh)
        DESC_A=$DESC_ZH_A
        DESC_B=$DESC_ZH_B
        ;;
    fr)
        DESC_A=$DESC_FR_A
        DESC_B=$DESC_FR_B
        ;;
    *)
        DESC_A=$DESC_EN_A
        DESC_B=$DESC_EN_B
        ;;
    esac
    author_A=$(grep 'author' "$MODDIR/../asoul_affinity_opt/module.prop" | cut -d '=' -f 2)
    if [ ! -d $MODDIR/../asoul_affinity_opt -o ! -d $MODDIR/../extreme_gt ]; then
        sed -i "s/^description=.*/description=$DESC_A/" "$HYPROP"
    elif [ "$author_A" != "nakixii" ]; then
        sed -i "s/^description=.*/description=$DESC_B/" "$HYPROP"
        touch $MODDIR/../asoul_affinity_opt/remove
    fi
}

# Hydro functions by AB
sh $MODDIR/assets/functions.sh

# Refresh rate control
if [[ -f /data/vendor/.tp ]]
then
  chattr -i /data/vendor/.tp
  rm -f /data/vendor/.tp
fi

sleep 10

adfr="/sys/kernel/oplus_display/adfr_config"
if [ -f "$adfr" ]; then
    echo "0x0" > "$adfr"
fi
enforce_refresh_rate
# Refresh rate control fin.

# Iris Helper by AB
nohup sh $MODDIR/iris/iris_helper.sh >/dev/null 2>&1 &
enforce_refresh_rate
# Iris Helper by AB fin.

#hydro_integrity_detect
hydro_cure_enforce