lock_val() {
    chown 0:0 $2
    chmod +w  $2
    echo "$1" | tee $2 > /dev/null 2>&1
    chmod a-w $2
}

write() {
    chmod +w $2
    echo "$1" | tee $2 > /dev/null 2>&1
}

init_android() {
    for i in gameopt_hal_service-1-0 thermal-engine vendor.urcc-hal-aidl; do stop $i; done
    device_config set_sync_disabled_for_tests until_reboot
    device_config put activity_manager use_compaction false
    device_config put activity_manager max_cached_processes 65535
    device_config put activity_manager max_phantom_processes 65535
}

init_swap() {
    swapoff /dev/block/zram0
    write "1" "/sys/class/block/zram0/reset"
    write "0" "/sys/class/block/zram0/mem_limit"
    write "zstd" "/sys/class/block/zram0/comp_algorithm"
    write "`cat /proc/meminfo | awk 'NR==1{print $2*1024}'`" "/sys/class/block/zram0/disksize"

    mkswap /dev/block/zram0
    swapon /dev/block/zram0
    rm /dev/block/zram0
    touch /dev/block/zram0 /dev/block/zram1
}

init_misc() {
    lock_val "none" "/sys/class/block/sda/queue/scheduler"
    lock_val "128" "/sys/class/block/sda/queue/read_ahead_kb"
    lock_val "92" "/sys/class/kgsl/kgsl-3d0/devfreq/mod_percent"
    lock_val "16" "/sys/class/kgsl/kgsl-3d0/min_pwrlevel"
}

init_cpu() {
    f=2147483647
    lock_val "0:$f 1:$f 2:$f 3:$f 4:$f 5:$f 6:$f 7:$f" "/sys/kernel/msm_performance/parameters/cpu_max_freq"
    lock_val "0:0 1:0 2:0 3:0 4:0 5:0 6:0 7:0" "/sys/kernel/msm_performance/parameters/cpu_min_freq"

    lock_val "1" "/sys/devices/system/cpu/bus_dcvs/DDRQOS/boost_freq"
    lock_val "0" "/sys/devices/system/cpu/dmof/disable_memcpy_optimization"
    lock_val "0" "/sys/devices/system/cpu/cpufreq/*/walt/*freq"
}

until [ -d /data/data/android ]; do sleep 1; done
settings put global settings_enable_monitor_phantom_procs false

# Performance adjustment
init_android; init_swap; init_misc; init_cpu
# Performance adjustment fin.